#NOTE: with 3 cores, the result is similar to 2 cores and 1 core.

library(rbenchmark)

# Mean along 1 dim
benchmark("s2dv, 1 core" = {
            data <- array(rnorm(1:60000),
                          dim = c(dat = 1, time = 12, member = 60, lon = 20, lat = 50))
            res <- s2dv::InsertDim(data, 2, 10, 'new', ncores = 1)
          },

          "s2dv, 2 cores" = {
            data <- array(rnorm(1:60000),
                          dim = c(dat = 1, time = 12, member = 60, lon = 20, lat = 50))
             res <- s2dv::InsertDim(data, 2, 10, 'new', ncores = 2)
          },

          "s2dverification" = {
             data <- array(rnorm(1:60000),
                           dim = c(dat = 1, time = 12, member = 60, lon = 20, lat = 50))
             res <- s2dverification::InsertDim(data, 2, 10)
          },
          replications = 10,
          columns = c("test", "replications", "elapsed",
                      "relative", "user.self", "sys.self"))

# member = 5, lendim = 2
             test replications elapsed relative user.self sys.self
1    s2dv, 1 core           10   0.213    8.192     0.200    0.012
2   s2dv, 2 cores           10   0.283   10.885     0.172    0.060
3 s2dverification           10   0.026    1.000     0.024    0.000

# member = 50, lendim = 10
             test replications elapsed relative user.self sys.self
1    s2dv, 1 core           10   8.184    6.243     7.708    0.436
2   s2dv, 2 cores           10   7.937    6.054     4.752    0.800
3 s2dverification           10   1.311    1.000     1.237    0.064

             test replications elapsed relative user.self sys.self
1    s2dv, 1 core           10   7.793    5.886     7.320    0.452
2   s2dv, 2 cores           10   8.002    6.044     4.740    0.872
3 s2dverification           10   1.324    1.000     1.232    0.080

# member = 60, lendim = 10
             test replications elapsed relative user.self sys.self
1    s2dv, 1 core           10   9.370    5.827     8.828    0.508
2   s2dv, 2 cores           10   9.443    5.873     5.733    0.844
3 s2dverification           10   1.608    1.000     1.492    0.112

