#///////////////////////////////////////////////////////////////////////////////////
#NOTE: This test doesn't work. assign() is different from .InsertDim. See 'DIFFERENCE' below.
#///////////////////////////////////////////////////////////////////////////////////
library(s2dv)
library(rbenchmark)

# Replace .InsertDim with assign
InsertDim_assign <- function(data, posdim, lendim, name = NULL, ncores = NULL) {

  ###############################
  # Calculate InsertDim

  ## create output dimension
  outdim <- lendim
  if (posdim > 1) {
    outdim <- c(dim(data)[1:(posdim - 1)], outdim)
  }
  if (posdim <= length(dim(data))) {
    outdim <- c(outdim, dim(data)[posdim:length(dim(data))])
  }
  ## create output array
  outvar <- array(dim = c(outdim))
  ## give temporary names for Apply(). The name will be replaced by data in the end
#  names(dim(outvar)) <- paste0('D', 1:length(outdim))
  names(dim(outvar))[posdim] <- name #'new'

  res <- Apply(list(outvar), 
               margins = name, #'new', 
               fun = assign, #.InsertDim, 
               value = data
              )$output1

  if (posdim != 1) {
    if (posdim < length(outdim)) {
    res <- Reorder(res, c(1:(posdim - 1), length(outdim), posdim:(length(outdim) - 1)))
    } else {  #posdim = length(outdim)
        res <- Reorder(res, c(1:(posdim - 1), length(outdim)))
    }
  } else {
      res <- Reorder(res, c(length(outdim), 1:(length(outdim) - 1)))
  }

  return(res)
}



#Original
InsertDim_ori <- function(data, posdim, lendim, name = NULL, ncores = NULL) {

  ###############################
  # Calculate InsertDim

  ## create output dimension
  outdim <- lendim
  if (posdim > 1) {
    outdim <- c(dim(data)[1:(posdim - 1)], outdim)
  }
  if (posdim <= length(dim(data))) {
    outdim <- c(outdim, dim(data)[posdim:length(dim(data))])
  }
  ## create output array
  outvar <- array(dim = c(outdim))
  ## give temporary names for Apply(). The name will be replaced by data in the end
#  names(dim(outvar)) <- paste0('D', 1:length(outdim))
  names(dim(outvar))[posdim] <- name #'new'

  res <- Apply(list(outvar),
               margins = name, #'new', 
               fun = .InsertDim,
               val = data
              )$output1

  if (posdim != 1) {
    if (posdim < length(outdim)) {
    res <- Reorder(res, c(1:(posdim - 1), length(outdim), posdim:(length(outdim) - 1)))
    } else {  #posdim = length(outdim)
        res <- Reorder(res, c(1:(posdim - 1), length(outdim)))
    }
  } else {
      res <- Reorder(res, c(length(outdim), 1:(length(outdim) - 1)))
  }

  return(res)
}

#/////////////DIFFERENCE/////////////////
#-----------------------------
a <- 1:4
.InsertDim(a[1],5)
[1] 5
get('a[1]')
Error in get("a[1]") : object 'a[1]' not found

assign('a[1]', 5)
get('a[1]')
[1] 5
#-----------------------------
#////////////////////////////////////////


# Test
benchmark(".InsertDim" = {
            data <- array(rnorm(1:1000),
                          dim = c(dat = 1, time = 12, member = 50, lon = 360, lat = 180))
            res_MeanDims <- s2dv::MeanDims(data, 3)
          },

          "assign" = {
            data <- array(rnorm(1:1000),
                          dim = c(dat = 1, time = 12, member = 50, lon = 360, lat = 180))
             res_Mean1Dim <- s2dverification::Mean1Dim(data, 3)
          },

          replications = 10,
          columns = c("test", "replications", "elapsed",
                      "relative", "user.self", "sys.self"))
