library(s2dverification) 

exp <- list(
         name = 'exp',
         path = paste0('/esarchive/exp/ecmwf/system5_m1/monthly_mean/',
              '$VAR_NAME$_f6h/$VAR_NAME$_$START_DATE$.nc')
       )
obs <- list(
        name = 'obs',
        path = paste0('/esarchive/recon/ecmwf/era5/monthly_mean/',
               '$VAR_NAME$_f1h/$VAR_NAME$_$YEAR$$MONTH$.nc')
       )

lons.min <- -80 #-180
lons.max <- 40 #179.9
lats.min <- 20 #-10
lats.max <- 80 #90
var_name <- 'tas'


data <- Load(var = var_name,
             exp = list(exp),
             obs = list(obs),
             sdates = paste0(1995:1999, '1101'),
             leadtimemin = 1,
             leadtimemax = 2,
             nmember = 2,
             output = 'lonlat',
             grid = 'r360x181',
             method = 'conservative',
             storefreq = 'monthly',
             latmin = lats.min,
             latmax = lats.max,
             lonmin = lons.min,
             lonmax = lons.max)
dim(data$mod)
dim(data$obs)
lon <- data$lon  # [0, 360]
lat <- data$lat  # [90, -90]

lat_ind <- which(lat >= 20 & lat <= 80)
lon_ind <- which((lon >= 0 & lon <= 40) | (lon <= 360 & lon >= (360-80)))

ano <- Ano_CrossValid(data$mod, data$obs)
str(ano)
ano_exp <- Subset(ano$ano_exp, c('lat', 'lon'), list(lat_ind, lon_ind))
ano_obs <- Subset(ano$ano_obs, c('lat', 'lon'), list(lat_ind, lon_ind))
dim(ano_exp)

nao <- NAO(ano_exp, ano_obs, lon = lon[lon_ind], lat = lat[lat_ind])

nao <- NAO(ano_exp, ano_obs, lon = lon, lat = lat)
