library(startR)
library(s2dverification)

  repos <- "/esarchive/exp/ecmwf/system5_m1/monthly_mean/$var$_f6h/$var$_$sdate$.nc"
  var <- 'tas'
  sdate <- paste0(2008:2018, '0101')

  data <- Start(dat = repos,
                var = var,
                sdate = sdate,
                ensemble = indices(c(1:15)),
                time = 'all',
                latitude = 'all', #indices(1:40),
                longitude = 'all', #indices(1:49),
                return_vars = list(longitude = NULL, latitude = NULL),
                retrieve = FALSE
               )

 fun <- function(x) {
print(dim(x))
   s2dv::Clim(x, x, dat_dim = c('dat', 'ensemble'),ftime_dim = 'time', memb_dim = 'ensemble')$clim_exp
   #apply(x, c(which(names(dim(x)) != 'ensemble')), mean)
 }

  step <- Step(fun, target_dims = c('dat', 'sdate', 'ensemble', 'time'),
                    output_dims = c('dat', 'ensemble', 'time'))
  wf <- AddStep(data, step)

#Compute() locally
  res <- Compute(wf,
                 chunks = list(latitude = 4,
                               longitude = 4))

