
library(s2dverification)
library(s2dv)

  ecearth <- list(name = 'm04o',
                  path = file.path('/esarchive/exp/ecearth',
                                   '/$EXP_NAME$/monthly_mean',
                                   '/$VAR_NAME$_f6h/$VAR_NAME$_$START_DATE$.nc'))

  ecmwf <- list(name = 'system5c3s',
                path = file.path('/esarchive/exp/ecmwf',
                                 '/$EXP_NAME$/monthly_mean',
                                 '/$VAR_NAME$_f6h/$VAR_NAME$_$START_DATE$.nc'))

  era5 <- list(name = 'era5',
               path = file.path('/esarchive/recon/ecmwf',
                                '$OBS_NAME$/monthly_mean',
                                '$VAR_NAME$_f1h/$VAR_NAME$_$YEAR$$MONTH$.nc'))

  startDates <- c(paste0(2001:2002,'1101'))
  time_length <- 4
  lon <- c(-6, 36)
  lat <- c(30, 46)

  data <- Load(var = 'psl',
               exp = list(ecearth, ecmwf),
               obs = list(era5),
               sdates = startDates,
               storefreq = "monthly",
               leadtimemax = time_length,
               output = 'lonlat',
               lonmin = lon[1], lonmax = lon[2],
               latmin = lat[1], latmax = lat[2])

library(pryr)
print('memory_used')
print(mem_used())

# s2dverification
start <- Sys.time()
res1 <- s2dverification::Clim(data$mod, data$obs)
end <- Sys.time()
total1 <- end - start
print(total1)


# s2dv
start <- Sys.time()
res2 <- s2dv::Clim(data$mod, data$obs)
end <- Sys.time()
total2 <- end - start
print(total2)

