library(s2dverification)
library(s2dv)
#ACC_new <- s2dv::ACC
source('/home/Earth/aho/s2dv/R/ACC.R')
ACC_new <- ACC
ACC_old <- s2dverification::ACC
#NOTE: need to run in different console because ACC uses Eno.

  # dat1
  set.seed(1)
  exp1 <- array(rnorm(60), dim = c(dataset = 1, member = 2, sdate = 5,
                                   ftime = 1, lat = 2, lon = 3))

  set.seed(2)
  obs1 <- array(rnorm(30), dim = c(dataset = 1, member = 1, sdate = 5,
                                   ftime = 1, lat = 2, lon = 3))
  # dat2
  set.seed(1)
  exp2 <- array(rnorm(60), dim = c(dataset = 2, sdate = 5,
                                   ftime = 1, lat = 2, lon = 3))
  set.seed(2)
  obs2 <- array(rnorm(30), dim = c(dataset = 1, sdate = 5,
                                   ftime = 1, lat = 2, lon = 3))
  set.seed(2)
  na <- floor(runif(2, min = 1, max = 30))
  obs2[na] <- NA

  # dat3
  exp3 <- exp1
  obs3 <- obs1
  obs3[2] <- NA
  obs3[27] <- NA

##############################################

# dat1
res_new_1 <- ACC_new(exp1, obs1)
res_old_1 <- ACC_old(exp1, obs1)

res_new_1$macc
res_old_1$MACC

res_new_1$acc[1, 1, , 1]
res_old_1$ACC[1, 1, , 1, 2]

res_new_1$conf.upper[1, 1, , 1]
res_old_1$ACC[1, 1, , 1, 1]

res_new_1$conf.lower[1, 1, , 1]
res_old_1$ACC[1, 1, , 1, 3]

res_new_1 <- ACC_new(exp1, obs1, lat = c(10, 20), lon = c(20, 30, 40),
                     lonlatbox  = c(20, 30, 10, 20))$acc
res_old_1 <- ACC_old(exp1, obs1, lat = c(10, 20), lon = c(20, 30, 40),
                     lonlatbox  = c(20, 30, 10, 20))$ACC[1, 1, , 1, 2]

## bootstrap
res_new_1 <- ACC_new(exp1, obs1, conftype = "bootstrap")
res_old_1 <- ACC_old(exp1, obs1, conftype = "bootstrap")
# ACC
res_new_1$acc[1, 1, , 1]
res_old_1$ACC[1, 1, , 1, 2]
res_new_1$acc_conf.lower[1, 1, , 1]
res_old_1$ACC[1, 1, , 1, 1]
res_new_1$acc_conf.upper[1, 1, , 1]
res_old_1$ACC[1, 1, , 1, 3]
# MACC
res_new_1$macc[1, 1, 1]
res_old_1$MACC[1, 1, 1, 2]
#------------They are different-------------
res_new_1$macc_conf.upper[1, 1, 1]   
res_old_1$MACC[1, 1, 1, 3]  #upper
res_new_1$macc_conf.lower[1, 1, 1]   
res_old_1$MACC[1, 1, 1, 1]  #lower
#------------------------------------------



# dat2
res_new_2 <- ACC_new(exp2, obs2, memb_dim = NULL)
res_old_2 <- ACC_old(exp2, obs2)

res_new_2$macc
res_old_2$MACC

res_new_2$acc[1, 1, , 1]
res_old_2$ACC[1, 1, , 1, 2]

res_new_2$acc[2, 1, , 1]
res_old_2$ACC[2, 1, , 1, 2]

res_new_2$conf.upper[1, 1, , 1]
res_old_2$ACC[1, 1, , 1, 1]

res_new_2$conf.lower[1, 1, , 1]
res_old_2$ACC[1, 1, , 1, 3]

res_new_2$p.val[1, 1, , 1]
res_old_2$ACC[1, 1, , 1, 4]


#dat3

## bootstrap
res_new_3 <- ACC_new(exp3, obs3, conftype = "bootstrap")
res_old_3 <- ACC_old(exp3, obs3, conftype = "bootstrap")
# ACC
res_new_3$acc[1, 1, , 1]
res_old_3$ACC[1, 1, , 1, 2]
res_new_3$acc_conf.lower[1, 1, , 1]
res_old_3$ACC[1, 1, , 1, 1]
res_new_3$acc_conf.upper[1, 1, , 1]
res_old_3$ACC[1, 1, , 1, 3]
# MACC
res_new_3$macc[1, 1, 1]
res_old_3$MACC[1, 1, 1, 2]
#------------They are different-------------
res_new_3$macc_conf.upper[1, 1, 1]
res_old_3$MACC[1, 1, 1, 3]  #upper
res_new_3$macc_conf.lower[1, 1, 1]
res_old_3$MACC[1, 1, 1, 1]  #lower
#-------------------------------------------

