library(s2dverification)
library(multiApply)
source('/home/Earth/aho/s2dv/R/Histo2Hindcast.R')

Histo2Hindcast_old <- s2dverification::Histo2Hindcast

set.seed(1)
dat1 <- array(rnorm(96), dim = c(dat = 1, memb = 2, sdate = 1, ftime = 24, lon = 2))

# (1)
sdate_in <- c('19901101')
sdate_out <- c('19901101', '19911101')
ftime_length <- 12

res_old <- Histo2Hindcast_old(dat1, sdatesin = sdate_in, sdatesout = sdate_out, 
                              nleadtimesout = ftime_length)
res_new <- Histo2Hindcast(dat1, sdatesin = sdate_in, sdatesout = sdate_out,  
                          nleadtimesout = ftime_length)

dim(res_old)
dim(res_new)

identical(mean(res_old), mean(res_new))

# (2)
sdate_in <- c('19901101')
sdate_out <- c('19901101', '19911101')
ftime_length <- 5

res_old <- Histo2Hindcast_old(dat1, sdatesin = sdate_in, sdatesout = sdate_out,                               nleadtimesout = ftime_length)
res_new <- Histo2Hindcast(dat1, sdatesin = sdate_in, sdatesout = sdate_out,
                          nleadtimesout = ftime_length)
identical(mean(res_old), mean(res_new))


# (3) DIFFERENT!!!! old version assumes that all sdate_out has the same month
sdate_in <- c('19901101')
sdate_out <- c('19901101', '19910101')
ftime_length <- 4

res_old <- Histo2Hindcast_old(dat1, sdatesin = sdate_in, sdatesout = sdate_out,                               nleadtimesout = ftime_length)
res_new <- Histo2Hindcast(dat1, sdatesin = sdate_in, sdatesout = sdate_out,
                          nleadtimesout = ftime_length)

identical(mean(res_old), mean(res_new))

# (4)
sdate_in <- c('19901101')
sdate_out <- c('19901101', '19911101')
ftime_length <- 20

res_old <- Histo2Hindcast_old(dat1, sdatesin = sdate_in, sdatesout = sdate_out,                               nleadtimesout = ftime_length)
res_new <- Histo2Hindcast(dat1, sdatesin = sdate_in, sdatesout = sdate_out,
                          nleadtimesout = ftime_length)

identical(mean(res_old), mean(res_new))
identical(length(which(is.na(res_old)), length(which(is.na(res_new)))
identical(as.vector(res_old[1,2,,,1]), as.vector(res_new[,,1,2,1]))

