#library(s2dverification)

##########################
  set.seed(1)
  exp <- array(rnorm(240), dim = c(dataset = 1, member = 2, sdate = 5,
                                   ftime = 3, lat = 2, lon = 4))

  set.seed(2)
  obs <- array(rnorm(120), dim = c(dataset = 1, member = 1, sdate = 5,
                                   ftime = 3, lat = 2, lon = 4))
  set.seed(2)
  na <- floor(runif(10, min = 1, max = 120))
  obs[na] <- NA

  # 1
  res_old <- Corr(exp, obs, posloop = 2, poscor = 3, method = 'pearson')
  res_new <- Corr(exp, obs, method = 'pearson')

  # 2
  res_old <- Corr(exp, obs, posloop = 2, poscor = 3, compROW = 4, method = 'pearson')
  res_new <- Corr(exp, obs, method = 'pearson', comp_dim = 'ftime')

  # 3
  res_old <- Corr(exp, obs, posloop = 2, poscor = 3, method = 'spearman')
  res_new <- Corr(exp, obs, method = 'spearman')


##########################

