library(s2dverification)

exp <- list(
         name = 'exp',
         path = paste0('/esarchive/exp/ecmwf/system5_m1/monthly_mean/',
              '$VAR_NAME$_f6h/$VAR_NAME$_$START_DATE$.nc')
       )
obs <- list(
        name = 'obs',
        path = paste0('/esarchive/recon/ecmwf/era5/monthly_mean/',
               '$VAR_NAME$_f1h/$VAR_NAME$_$YEAR$$MONTH$.nc')
       )

lons.min <- -180
lons.max <- 179.9
lats.min <- -10
lats.max <- 90
var_name <- 'tas'


data <- Load(var = var_name,
             exp = list(exp),
             obs = list(obs),
             sdates = paste0(1995:1999, '1101'),
             leadtimemin = 1,
             leadtimemax = 7,
             nmember = 2,
             output = 'lonlat',
             grid = 'r360x181',
             method = 'conservative',
             storefreq = 'monthly',
             latmin = lats.min,
             latmax = lats.max,
             lonmin = lons.min,
             lonmax = lons.max)
dim(data$mod)
dim(data$obs)
lon <- data$lon  # [0, 360]
lat <- data$lat  # [90, -90]

obs1 <- Load(var = var_name,
             obs = list(list(path = pobs)),
             sdates = '20181101',
             leadtimemin = 1,
             leadtimemax = 1,
             output = 'lonlat',
             grid = 'r360x181',
             method = 'conservative',
             storefreq = 'monthly',
             latmin = lats.min,
             latmax = lats.max,
             lonmin = lons.min,
             lonmax = lons.max)


#----------------------------------------------------
# system4_m1
'/esarchive/exp/ecmwf/system4_m1/daily_mean/psl_f6h/psl_19911201.nc'
# erainterim
'/esarchive/recon/ecmwf/erainterim/daily_mean/psl_f6h/psl_199112.nc'
# system5c3s
'/esarchive/exp/ecmwf/system5c3s/daily_mean/prlr_s0-24h/prlr_20100501.nc'

#-----------------------------------
# use config
data <- Load('prlr', exp = 'system5c3s',
                         obs = 'era5',
                         sdates = c('20100501', '20110501', '20120501'),
                         #leadtimemin = 121, leadtimemax = 151,
                         latmin = 44, latmax = 47,
                         lonmin = 5, lonmax = 9,
                         nmember = 2,
                         storefreq = "daily", sampleperiod = 1,
                         output = "lonlat")
#---------------------------------------


#----------it does not work----------------------
pobs <- paste0('/esarchive/recon/ecmwf/erainterim/daily_mean/',
               '$VAR_NAME$_f6h/$VAR_NAME$_$YEAR$$MONTH$.nc')
pexp <- paste0('/esarchive/exp/ecmwf/system5c3s/daily_mean/',
               '$VAR_NAME$_s0-24h/$VAR_NAME$_$YEAR$$MONTH$.nc')

data <- Load('prlr',
             obs = list(list(path = pobs)),
             exp = list(list(path = pexp)),
             sdates = c('20100501', '20110501', '20120501'),
             #leadtimemin = 121, leadtimemax = 151,
             latmin = 44, latmax = 47,
             lonmin = 5, lonmax = 9,
             nmember = 5,
             storefreq = "daily", sampleperiod = 1,
             output = "lonlat")
#-----------------------------------------------



