library(s2dverification)
library(s2dv)

# data
set.seed(1)
exp <- array(rnorm(120), dim = c(dataset = 2, member = 3, sdate = 5, ftime = 2, lon = 2))
set.seed(2)
obs <- array(rnorm(40),  dim = c(dataset = 1, member = 2, sdate = 5, ftime = 2, lon = 2))
obs[1,1, ,1,1] <- NA
exp[1,2,2,1,1] <- NA

# data 2
set.seed(1)
exp2 <- array(rnorm(240), dim = c(dataset = 2, member = 3, sdate = 5, ftime = 2, lat = 2, lon = 2))
set.seed(2)
obs2 <- array(rnorm(40),  dim = c(dataset = 1, member = 1, sdate = 5, ftime = 2, lat = 2, lon = 2))
exp2[1, 1,  , 2, 1, 1] <- NA
obs2[1, 1, 2, 2, 1, 1] <- NA


# s2dverification::Clim
res_s2dverification <- s2dverification::Clim(exp, obs)
res2_s2dverification <- s2dverification::Clim(exp2, obs2)


# apply

#per-paired. Remove the values in [, , 1:2, 1, , , ]
var_exp <- Enlarge(exp, 7)
var_obs <- Enlarge(obs, 7)
nan <- MeanListDim(var_exp, dims = c(1:2, 5:7), narm = FALSE) +
       MeanListDim(var_obs, dims = c(1:2, 5:7), narm = FALSE)

for (jdate in 1:dim(var_exp)[3]) {
  for (jtime in 1:dim(var_exp)[4]) {
    if (is.na(nan[jdate, jtime])) {
      var_exp[, , jdate, jtime, , , ] <- NA
      var_obs[, , jdate, jtime, , , ] <- NA
    }
  }
}

clim_obs <- apply(var_obs, MARGIN = c(1:2, 4:7), mean, na.rm = T)


# s2dv::Clim
res_s2dv <- s2dv::Clim(exp, obs)
res2_s2dv <- s2dv::Clim(exp2, obs2)

# compare
all.equal(res_s2dv, res_s2dverification)
all.equal(res2_s2dv, res2_s2dverification)




