func_forward <- function(cal, t, cal_choice, var, data) {

    print('func_forward starts!')

    
    #---------define colorbar-------------

    asd <- na.omit(as.vector(cal))
    if (!all(asd >= 0) && !all(asd <= 0)) {
      cbar <- c("bluered")
      #define brks
      bound <- max(abs(min(asd)), max(asd))
      brks <- seq(-bound + 0.0001,
                  bound - 0.0001,
                  length.out = 101)
    } else {
      cbar <- c("yellowred")
      #define brks
      brks <- seq(min(cal, na.rm = TRUE) + 0.0001,
                  max(cal, na.rm = TRUE) - 0.0001,
                  length.out = 101)
    }

    
    #--------retrieve lat, lon, and units for plotting-----------
    lon_name <- 'lon'
    if ('longitude' %in% names(dim(data))) {
      lon_name <- 'longitude'
    } else if ('i' %in% names(dim(data))) {
      if ('longitude' %in% names(attr(data, 'Variables')$common)) {
        lon_name <- 'longitude'
      } else if ('lon' %in% names(attr(data, 'Variables')$common)) {
        lon_name <- 'lon'
      }
    }
    
    lat_name <- 'lat'
    if ('latitude' %in% names(dim(data))) {
      lat_name <- 'latitude'
    } else if ('j' %in% names(dim(data))) {
      if ('latitude' %in% names(attr(data, 'Variables')$common)) {
        lat_name <- 'latitude'
      } else if ('lat' %in% names(attr(data, 'Variables')$common)) {
        lat_name <- 'lat'
      }
    }

    lons <- unique(as.vector(attr(data, 'Variables')$common[[lon_name]]))
    lats <- unique(as.vector(attr(data, 'Variables')$common[[lat_name]]))
    units <- attr(data, 'Variables')$common[[var]]$units

    #-------Find out 2D Map or 1D time series--------
    if (any(c('lat', 'latitude', 'j') %in% names(dim(data)))
        && any(c('lon', 'longitude', 'i') %in% names(dim(data)))) {
      is_map <- TRUE
    } else {
      is_map <- FALSE
    }

    print('func_forward over!')

    return(list(cal, is_map, lons, lats, units, t, brks, cbar))
  }  #forward
