func_type <- function(path, var) {

    print('in func_type')
    print(path)
    #get inner dim to see 1. if file exists, 2. (i, j) or (lat, lon)
    inner_dim <- try(easyNCDF::NcReadDims(path, var_names = var), silent = TRUE)
    #get lat/lon dim to see if it is regualr gridded. If > 2, irregular
    latlon_dim <- try(easyNCDF::NcReadDims(path, var_names = 'lat'), silent = TRUE)
    if (class(latlon_dim) == 'try-error') {
      latlon_dim <- try(easyNCDF::NcReadDims(path, var_names = 'latitude'), silent = TRUE)
    }

    
    type <- list()
    
    type$length <- length(inner_dim)
    type$latlondim <- length(latlon_dim)
    
    if (class(inner_dim) != 'try-error') {

      type$path <- path

      #then retrieve lat/lon, i/j, or time/region
      if (any(c('lat', 'latitude') %in% names(inner_dim))
          && any(c('lon', 'longitude') %in% names(inner_dim))) {

        type$dim <- 'latlon'

      } else if (all(c('i', 'j') %in% names(inner_dim))) {

        type$dim <- 'ij'
        type$length_j <- inner_dim['j']
        type$length_i <- inner_dim['i']
        type$var_list <- easyNCDF::NcReadVarNames(path)

      } else if (all(c('time', 'region') %in% names(inner_dim))) {

        type$dim <- 'time_region'

      } else if (c('time') %in% names(inner_dim)) {
        
        type$dim <- 'time'
      }
        
    } else {
      stop("File doesn't exist or data format is not available.")
    }
    type

}  #func ends
