func_cal <- function(type, path, rundate1, rundate2, subdata) {
  
  sub_list <- vector(mode = "list", length = length(subdata))
  
  ###########################################
  
  for (n in 1:length(subdata)) {
    
    type_dim <- subdata[[n]][[2]][[1]]$dim
    
    
    if(type_dim == 'latlon') {
      
      data <- Start(dat = subdata[[n]][[1]],  #path[[1]], #BUG: [[1]] should be removed!!
                    var = names(subdata[[n]][[2]]),  #var,
                    time = 'all',
                    lat = 'all',
                    lon = 'all',
                    return_vars = list(lon = NULL, lat = NULL),
                    synonims = list(lat = c('lat','latitude'),
                                    lon = c('lon','longitude')),
                    retrieve = FALSE)
      
    } else if (type_dim == 'ij') {
      
      lon_name <- 'lon'
      if ('longitude' %in% type$var_list) {
        lon_name <- 'longitude'
      }
      lat_name <- 'lat'
      if ('latitude' %in% type$var_list) {
        lat_name <- 'latitude'
      }
      
      data <- Start(dat = path,
                    var = names(subdata[[n]][[2]]),
                    time = 'all',
                    j = indices(1 : type$length_j),
                    i = indices(1 : type$length_i),
                    j_var = lat_name,
                    i_var = lon_name,
                    #return_vars = list(lat_name = NULL, lon_name = NULL),
                    retrieve = FALSE)
      
      
    } else if (type_dim == 'time') {    
      
      chunk1 <- paste0(rundate1, '-', as.numeric(rundate1) + 11)
      chunk2 <- paste0(as.numeric(rundate2) - 11, '-', rundate2)
      years <- as.numeric(substr(chunk1, 1, 4)):as.numeric(substr(chunk2, 1, 4))
      chunks <- paste0(years, '01-', years, '12')
      
      #re-make path, read in all periods
      # tmp <- gregexpr(pattern = grid, path)[[1]]  #BUG: [[1]] should be removed!!!!!!
      # new_path <- paste0(substr(path, 1, tmp[length(tmp)] + 2), '$periods$.nc')
      new_path <- paste0(substr(subdata[[n]][[1]], 1, nchar(subdata[[n]][[1]]) - 16), '$periods$.nc')
      
      data <- try(
        Start(dat = new_path,
              var = names(subdata[[n]][[2]]),
              periods = values(chunks),  #'all',
              time = 'all',
              time_across = 'periods',
              merge_across_dims = TRUE,
              retrieve = FALSE)
      )
      if (class(data) == 'try-error') {
        chunks <- paste0(years, '01-', years, '01')
        
        data <- try(
          Start(dat = new_path,
                var = names(subdata[[n]][[2]]),
                periods = values(chunks),
                time = 'all',
                time_across = 'periods',
                merge_across_dims = TRUE,
                retrieve = FALSE)
        )
      }
      
    } else if (type_dim == 'time_region') {    
      
      chunk1 <- paste0(rundate1, '-', as.numeric(rundate1) + 11)
      chunk2 <- paste0(as.numeric(rundate2) - 11, '-', rundate2)
      years <- as.numeric(substr(chunk1, 1, 4)):as.numeric(substr(chunk2, 1, 4))
      chunks <- paste0(years, '01-', years, '12')
      
      ##re-make path, read in all periods
      # tmp <- gregexpr(pattern = grid, subdata[[n]][[1]])[[1]]  #BUG: [[1]] should be removed!!!!!!
      # new_path <- paste0(substr(subdata[[n]][[1]], 1, tmp[length(tmp)] + 2), '$periods$.nc')
      new_path <- paste0(substr(subdata[[n]][[1]], 1, nchar(subdata[[n]][[1]]) - 16), '$periods$.nc')
      
      data <- try(
        Start(dat = new_path,
              var = names(subdata[[n]][[2]]),
              periods = values(chunks),
              time = 'all',
              region = 'all',
              time_across = 'periods',
              merge_across_dims = TRUE,
              retrieve = FALSE)
      )
      if (class(data) == 'try-error') {
        chunks <- paste0(years, '01-', years, '01')
        
        data <- try(
          Start(dat = new_path,
                var = names(subdata[[n]][[2]]),
                periods = values(chunks),
                time = 'all',
                region = 'all',
                time_across = 'periods',
                merge_across_dims = TRUE,
                retrieve = FALSE)
        )
      } 
      
    }
    
    sub_list[[n]] <- eval(data) 
    
  }  #for loop n
  
  ##########################################
  
  res <- sub_list  #eval(data)   #retrieve data
  
  res  #return result of all possibilities
}
