func_forward <- function(cal, t, subdata) {
  
  cal_ori <- cal  #keep the original cal
  n_list <- vector(mode = "list", length = length(cal_ori))
  
  for (n in 1:length(cal_ori)) {  #run through each list
    
    cal_n <- cal_ori[[n]]
    
    arg <- vector(mode = "list", length = length(names(subdata[[n]][[2]])))
    names(arg) <- names(subdata[[n]][[2]])
    
    
    for (kk in 1:length(arg)) {   #run through each var
      
      cal <- Subset(cal_n, 'var', kk)
      
      #---------define colorbar-------------
      
      asd <- na.omit(as.vector(cal))
      if (!all(asd >= 0) && !all(asd <= 0)) {
        cbar <- c("bluered")
        #define brks
        bound <- max(abs(min(asd)), max(asd))
        brks <- seq(-bound + 0.0001,
                    bound - 0.0001,
                    length.out = 101)
      } else {
        cbar <- c("yellowred")
        #define brks
        brks <- seq(min(cal, na.rm = TRUE) + 0.0001,
                    max(cal, na.rm = TRUE) - 0.0001,
                    length.out = 101)
      }
      
      
      #--------retrieve lat, lon, and units for plotting-----------

      lon_name <- 'lon'
      if ('longitude' %in% names(attr(cal, 'Variables')$common)) {
        lon_name <- 'longitude'
      } 
      
      lat_name <- 'lat'
      if ('latitude' %in% names(attr(cal, 'Variables')$common)) {
        lat_name <- 'latitude'
      } 
      
      lons <- unique(as.vector(attr(cal, 'Variables')$common[[lon_name]]))
      lats <- unique(as.vector(attr(cal, 'Variables')$common[[lat_name]]))
      units <- try(attr(cal, 'Variables')$common[[names(subdata[[n]][[2]])[kk]]]$units)   #BUG: NULL for non-first var, NULL for all var if retrieve = FALSE
      
      
      #-------Find out 2D Map or 1D time series--------
      if (any(c('lat', 'latitude', 'j') %in% names(attr(cal, 'Variables')$common))
          && any(c('lon', 'longitude', 'i') %in% names(attr(cal, 'Variables')$common))) {
        is_map <- TRUE
      } else {
        is_map <- FALSE
      }
      
      
      arg[[kk]] <- list(is_map = is_map, lons = lons, lats = lats, 
                             units = units, title = t[kk], brks = brks, cbar = cbar)
      
    } #for loop kk
    
    n_list[[n]] <- arg
    
  }  # for loop n
  
  return(n_list)
}  #forward
