func_cal <- function(type, path, rundate1, rundate2, subdata) {
  print('in func_cal')
  print('path')
  print(path)
  
  sub_list <- vector(mode = "list", length = length(subdata))
  
  ###########################################
  
  for (n in 1:length(subdata)) {
    
    type_dim <- subdata[[n]][[2]]$dim
    
    
    if(type_dim == 'latlon') {
      
      data <- Start(dat = subdata[[n]][[1]],  #path[[1]], #BUG: [[1]] should be removed!!
                    var = names(subdata)[n],  #var,
                    time = 'all',
                    lat = 'all',
                    lon = 'all',
                    return_vars = list(lon = NULL, lat = NULL),
                    synonims = list(lat = c('lat','latitude'),
                                    lon = c('lon','longitude')),
                    retrieve = FALSE)
      
    } else if (type_dim == 'ij') {
      
      lon_name <- 'lon'
      if ('longitude' %in% type$var_list) {
        lon_name <- 'longitude'
      }
      lat_name <- 'lat'
      if ('latitude' %in% type$var_list) {
        lat_name <- 'latitude'
      }
      
      data <- Start(dat = path,
                    var = names(subdata[[n]][[2]]),
                    time = 'all',
                    j = indices(1 : type$length_j),
                    i = indices(1 : type$length_i),
                    j_var = lat_name,
                    i_var = lon_name,
                    #return_vars = list(lat_name = NULL, lon_name = NULL),
                    retrieve = FALSE)
      
      
    } else if (type_dim == 'time') {    
      
      
      years <- as.numeric(substr(rundate1, 1, 4)):as.numeric(substr(rundate2, 1, 4))
      mths <- c(as.numeric(substr(rundate1, 5, 6)), as.numeric(substr(rundate2, 5, 6)))
      if (mths[1] <= mths[2]) {
        chunks <- paste0(years, sprintf('%02d', mths[1]), '-', years, sprintf('%02d', mths[2]))
      } else if (mths[1] > mths[2]) {  #cross years (e.g., 201811-201910)
        chunks <- rep(0, length(years) - 1)
        for (j in 1:length(years) - 1) {
          chunks[j] <- paste0(years[j], sprintf('%02d', mths[1]), '-', years[j + 1], sprintf('%02d', mths[2]))
        }
      }
      
      #re-make path, read in all periods
      # tmp <- gregexpr(pattern = grid, path)[[1]]  #BUG: [[1]] should be removed!!!!!!
      # new_path <- paste0(substr(path, 1, tmp[length(tmp)] + 2), '$periods$.nc')
      new_path <- paste0(substr(subdata[[n]][[1]], 1, nchar(subdata[[n]][[1]]) - 16), '$periods$.nc')
      
      data <- try(
        Start(dat = new_path,
              var = names(subdata)[n],
              periods = chunks, #values(chunks),  #'all',
              time = 'all',
              time_across = 'periods',
              merge_across_dims = TRUE,
              retrieve = FALSE)
      )
      if (class(data) == 'try-error') {
        chunks <- paste0(years, '01-', years, '01')
        
        data <- try(
          Start(dat = new_path,
                var = names(subdata)[n],
                periods = values(chunks),
                time = 'all',
                time_across = 'periods',
                merge_across_dims = TRUE,
                retrieve = FALSE)
        )
      }
      
    } else if (type_dim == 'time_region') {    

      years <- as.numeric(substr(rundate1, 1, 4)):as.numeric(substr(rundate2, 1, 4))
      mths <- c(as.numeric(substr(rundate1, 5, 6)), as.numeric(substr(rundate2, 5, 6)))
      if (mths[1] <= mths[2]) {
        chunks <- paste0(years, sprintf('%02d', mths[1]), '-', years, sprintf('%02d', mths[2]))
      } else if (mths[1] > mths[2]) {  #cross years (e.g., 201811-201910)
        chunks <- rep(0, length(years) - 1)
        for (j in 1:length(years) - 1) {
          chunks[j] <- paste0(years[j], sprintf('%02d', mths[1]), '-', years[j + 1], sprintf('%02d', mths[2]))
        }
      }
      
      print('chunks in func_cal')
      print(chunks)
      
      ##re-make path, read in all periods
      # tmp <- gregexpr(pattern = grid, subdata[[n]][[1]])[[1]]  #BUG: [[1]] should be removed!!!!!!
      # new_path <- paste0(substr(subdata[[n]][[1]], 1, tmp[length(tmp)] + 2), '$periods$.nc')
      new_path <- paste0(substr(subdata[[n]][[1]], 1, nchar(subdata[[n]][[1]]) - 16), '$periods$.nc')

      data <- try(
        Start(dat = new_path,  # $path$
              var = names(subdata)[n],
              periods = chunks,  #values(chunks),
              time = 'all',
              region = 'all',
              time_across = 'periods',
              merge_across_dims = TRUE,
              retrieve = FALSE)
      )
      # if (class(data) == 'try-error') {
      #   chunks <- paste0(years, '01-', years, '01')
      #   
      #   data <- try(
      #     Start(dat = new_path,
      #           var = names(subdata)[n],
      #           periods = values(chunks),
      #           time = 'all',
      #           region = 'all',
      #           time_across = 'periods',
      #           merge_across_dims = TRUE,
      #           retrieve = FALSE)
      #   )
      # } 
      
    }
    
    sub_list[[n]] <- eval(data) 
    
  }  #for loop n
  
  ##########################################
  
  names(sub_list) <- names(subdata)
  print("names(sub_list)")
  print(names(sub_list))
  
  print('func_cal over')
  
  return(sub_list)
}
