func_cal <- function(path, rundate1, rundate2, subdata, lev) {

 withProgress(message = 'Loading data ...', value = 0, {
 
  print('in func_cal')
 print('lev')
print(lev)

  sub_list <- vector(mode = "list", length = length(subdata))
  
  ###########################################
  
  for (n in 1:length(subdata)) {

    # Increment the progress bar, and update the detail text.
    incProgress(1/(length(subdata) + 1),
                detail = paste0("variable ", n, " of ", length(subdata)))
    
    type_dim <- subdata[[n]][[2]]$dim
    type_dimnames <- subdata[[n]][[2]]$dimnames
    lev_name <- c('lev', 'level', 'height', 'depth', 'plev')

    if(type_dim == 'latlon') {
      if (!any(lev_name %in% type_dimnames)) {  # no lev in dimension (2D map)
        data <- Start(dat = subdata[[n]][[1]],  #path[[1]], #BUG: [[1]] should be removed??
                      var = names(subdata)[n],  #var,
                      time = 'all',
                      lat = 'all',
                      lon = 'all',
                      return_vars = list(lon = NULL, lat = NULL),
                      synonims = list(lat = c('lat','latitude'),
                                      lon = c('lon','longitude')),
                      retrieve = FALSE)
      } else {  # 3D map
        data <- Start(dat = subdata[[n]][[1]],  #path[[1]], #BUG: [[1]] should be removed??
                      var = names(subdata)[n],  #var,
                      time = 'all',
                      lat = 'all',
                      lon = 'all',
                      lev = as.numeric(lev), #indices(1), # 'all',
                      return_vars = list(lon = NULL, lat = NULL),
                      synonims = list(lat = c('lat','latitude'),
                                      lon = c('lon','longitude'),
                                      lev = lev_name),
                      retrieve = FALSE)
      }
      #----------NEW_END--------------
      
    } else if (type_dim == 'ij') {
      
#      lon_name <- 'lon'
#      if ('longitude' %in% type_dimnames) {
#        lon_name <- 'longitude'
#      }
#      lat_name <- 'lat'
#      if ('latitude' %in% type_dimnames) {
#        lat_name <- 'latitude'
#      }
#      
#      data <- Start(dat = subdata[[n]][[1]],
#                    var = names(subdata)[n],
#                    time = 'all',
#                    j = indices(1 : subdata[[n]][[2]]$length_j),
#                    i = indices(1 : subdata[[n]][[2]]$length_i),
#                    j_var = lat_name,
#                    i_var = lon_name,
#                    #return_vars = list(lat_name = NULL, lon_name = NULL),
#                    retrieve = FALSE)
       data <- NA      
      
    } else if (type_dim == 'time') {    
      
      years <- as.numeric(substr(rundate1, 1, 4)):as.numeric(substr(rundate2, 1, 4))
      mths <- c(as.numeric(substr(rundate1, 5, 6)), as.numeric(substr(rundate2, 5, 6)))
      if (mths[1] <= mths[2]) {
        chunks <- paste0(years, sprintf('%02d', mths[1]), '-', years, sprintf('%02d', mths[2]))
      } else if (mths[1] > mths[2]) {  #cross years (e.g., 201811-201910)
        chunks <- rep(0, length(years) - 1)
        for (j in 1:length(years) - 1) {
          chunks[j] <- paste0(years[j], sprintf('%02d', mths[1]), '-', years[j + 1], sprintf('%02d', mths[2]))
        }
      }
      
      #re-make path, read in all periods
      new_path <- paste0(substr(subdata[[n]][[1]], 1, nchar(subdata[[n]][[1]]) - 16), '$periods$.nc')
      
      data <- try(
        Start(dat = new_path,
              var = names(subdata)[n],
              periods = chunks,
              time = 'all',
              time_across = 'periods',
              merge_across_dims = TRUE,
              retrieve = FALSE)
      )
      
    } else if (type_dim == 'time_region') {    
      
      years <- as.numeric(substr(rundate1, 1, 4)):as.numeric(substr(rundate2, 1, 4))
      mths <- c(as.numeric(substr(rundate1, 5, 6)), as.numeric(substr(rundate2, 5, 6)))
      if (mths[1] <= mths[2]) {
        chunks <- paste0(years, sprintf('%02d', mths[1]), '-', years, sprintf('%02d', mths[2]))
      } else if (mths[1] > mths[2]) {  #cross years (e.g., 201811-201910)
        chunks <- rep(0, length(years) - 1)
        for (j in 1:length(years) - 1) {
          chunks[j] <- paste0(years[j], sprintf('%02d', mths[1]), '-', years[j + 1], sprintf('%02d', mths[2]))
        }
      }
      
      ##re-make path, read in all periods
      new_path <- paste0(substr(subdata[[n]][[1]], 1, nchar(subdata[[n]][[1]]) - 16), '$periods$.nc')
     
      if (!any(lev_name %in% type_dimnames)) {  # no lev in dimension  
        data <- try(
          Start(dat = new_path,
                var = names(subdata)[n],
                periods = chunks, 
                time = 'all',
                region = 'all',
                time_across = 'periods',
                merge_across_dims = TRUE,
                retrieve = FALSE)
        )
      } else {  # lev in dimension 
        data <- try(
          Start(dat = new_path,
                var = names(subdata)[n],
                periods = chunks, 
                time = 'all',
                region = 'all',
                time_across = 'periods',
                merge_across_dims = TRUE,
                lev = as.numeric(lev),
                synonims = list(lev = lev_name),
                retrieve = FALSE)
        )
      }
    }  # else if (type_dim == 'time_region')

    sub_list[[n]] <- eval(data) 
    
  }  #for loop n

  incProgress(1/(length(subdata) + 1),
              detail = "finished.")
  
  ##########################################
  
  names(sub_list) <- names(subdata)
  
  print('func_cal over')

  })  # progress
  
  return(sub_list)
}
