func_type <- function(path, var) {
  
  print('In func_type!!')
  
  type <- vector(mode = "list", length = length(var))
  names(type) <- var
  
  #change $path$ back to path
  path_kk <- lapply(1:length(var), function(kk) gsub('var', var[kk], path[[kk]]))
  path_kk <- lapply(1:length(var), function(kk) gsub('[$]','', path_kk[[kk]]))
  
  
  #get inner dim to see 1. if file exists, 2. (i, j) or (lat, lon)
  inner_dim <- lapply(1:length(var), function(kk) try(easyNCDF::NcReadDims(path_kk[[kk]], var_names = var[kk]), silent = TRUE))
  #get lat/lon dim to see if it is regualr gridded. If > 2, irregular.
  latlon_dim <- vector(mode = "list", length = length(var))
  for (kk in 1:length(var)) { 
    latlon_dim[[kk]] <- try(easyNCDF::NcReadDims(path_kk[[kk]], var_names = 'lat'), silent = TRUE)
  if (class(latlon_dim[[kk]]) == 'try-error') {
    latlon_dim[[kk]] <- try(easyNCDF::NcReadDims(path_kk[[kk]], var_names = 'latitude'), silent = TRUE)
    }
    if (class(latlon_dim[[kk]]) == 'try-error') {  # not map
      latlon_dim[[kk]] <- NA
    }
  }

  for (kk in 1:length(var)) { 
    
    if (class(inner_dim[[kk]]) != 'try-error') {

      type[[kk]]$length <- length(inner_dim[[kk]])
      type[[kk]]$latlondim <- length(latlon_dim[[kk]])
      type[[kk]]$dimnames <- names(inner_dim[[kk]])
      type[[kk]]$dimensions <- inner_dim[[kk]]
      type[[kk]]$path <- path_kk[[kk]]  #path[[kk]]
      
      #then retrieve lat/lon, i/j, or time/region
      if (any(c('lat', 'latitude') %in% names(inner_dim[[kk]]))
          && any(c('lon', 'longitude') %in% names(inner_dim[[kk]]))) {
        
        type[[kk]]$dim <- 'latlon'
        
      } else if (all(c('i', 'j') %in% names(inner_dim[[kk]]))) {
        
        type[[kk]]$dim <- 'ij'
        type[[kk]]$length_j <- inner_dim['j']
        type[[kk]]$length_i <- inner_dim['i']
        type[[kk]]$var_list <- easyNCDF::NcReadVarNames(path_kk[[kk]])
        
      } else if (all(c('time', 'region') %in% names(inner_dim[[kk]]))) {
        
        type[[kk]]$dim <- 'time_region'
        type[[kk]]$regions <- as.vector(easyNCDF::NcToArray(path_kk[[kk]], vars_to_read = 'region'))
        
      } else if (c('time') %in% names(inner_dim[[kk]])) {
        
        type[[kk]]$dim <- 'time'
      }
      
    } else {
print('netCDF has problems!!')
      type[[kk]] <- NA
    }
  }
  print('type over')
  type
  
}  #func ends
