### Clean workspace
rm(list=ls())

# R -> python interface library
library(reticulate)

# load mapgenerator python library
plotmap <- import("mapgenerator.plotting.plotmap")

# some parameters 
#path_netCDF <- "/esarchive/exp/ecearth/a1tn/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r14i1p1f1/Omon/tos/gn/v20190312/tos_Omon_EC-Earth3_historical_r14i1p1f1_gn_201301-201312.nc"
#var_netCDF <- "tos"

dir <- "/esarchive/exp/ecearth/a1tr/diags/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r24i1p1f1/Omon/heatc0-300m/gn/v20190312/"
path_netCDF <- c(1:2)
path_netCDF[1] <- "heatc0-300m_Omon_EC-Earth3_historical_r24i1p1f1_gn_201301-201312.nc"
path_netCDF[2] <- "heatc0-300m_Omon_EC-Earth3_historical_r24i1p1f1_gn_201401-201412.nc"
path_netCDF <- paste0(dir, path_netCDF)
var_netCDF <- "heatc0-300m"

title <- "Tos %(year)s %(MONTH)s"
outdir <- "/home/Earth/aho/aho-testtest/shiny"

# create instance of the PlotMap class
pm <- plotmap$PlotMap()

# simple plotting function with only mandatory options
pm$plot(srcfiles = path_netCDF,
        srcvars = var_netCDF, outdir = outdir)

bounds <- paste0('0', '-', '4', ',', '0.1')
ticks <- paste0('0', '-', '4', ',', '0.5')

for (i in 1:2) {
# plotting function with more options 
pm$plot(srcfiles = path_netCDF[i],
        srcvars = var_netCDF,
        #title = title,
        outdir = outdir,
        img_template = paste0("output_",i,"_%(step)s"),
        lon = "0-360,60",
        lat = "m90-90,30",
        coordsopts = "0,6,grey",
        ysize = 0.7,
        coastsopts = "0.1,grey",
        resolution = 'l',
        #ticks = "0-30,5",
        #bounds = "0-35,0.5",
        ticks = ticks,
        bounds = bounds,
        colors = 'RdYlBu_r', #"viridis",
        timesteps = "all",
        anim = T)
}

