#library(testthat)
#library(startR)
context("Generic tests")
test_that("Sanity checks", {


#==================== 2 ========================
#----- ex2_1_timedim.R  -------

  repos <- '/esarchive/exp/ecmwf/system5_m1/monthly_mean/$var$_f6h/$var$_$sdate$.nc'
  data <- Start(dat = repos,
                var = 'tas',
                sdate = c('20170101', '20180101'),
                ensemble = indices(1:2),
                time = 'all',
                latitude = 'all',
                longitude = indices(1:2),
                return_vars = list(latitude = 'dat', longitude = 'dat', time = 'sdate'),
                retrieve = FALSE)
  library(multiApply)
  fun_spring <- function(x) {
      source("/esarchive/scratch/nperez/Season_v2.R")
      y <- Season_v2(x,  monini = 1, moninf = 3, monsup = 5)
      return(y)
  }

  step1 <- Step(fun = fun_spring,
               target_dims = c('time'),
               output_dims = c('time'))

  wf1 <- AddStep(data, step1)

## locally
  res1 <- Compute(wf1,
                  chunks = list(ensemble = 2, sdate = 2),#$output1
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = 'fat',
                                queue_type = 'slurm',
                                cores_per_job = 2,
                                job_wallclock = '00:10:00',
                                max_jobs = 4,
                                bidirectional = TRUE
                 ),
                 ecflow_suite_dir = '/home/Earth/aho/startR_local/'
#                 wait = TRUE
         )


  expect_equal(
    summary(res1$output1)[4],
    c(Mean=280.2)
  )



})
