library(startR)

DatesSequence <- function(sdate, inimonth, finalmonth, lag, nyears) {
  if (!is.numeric(sdate)) {
     sdate <- as.numeric(sdate)
  }
  sequence <- unlist(lapply(sdate, function(x) {
                a <- paste0((x + lag): (x + nyears),
                           sprintf('%02d', inimonth))
                b <- paste0((x + lag): (x + nyears),
                          sprintf('%02d', finalmonth))
                return(paste0(a, '-', b))}))
  sequence <- array(sequence,
                    c(chunk = length(sequence)/length(sdate), sdate = length(sdate)))
#                    c(sdate = length(sdate),
#                      chunk = length(sequence)/length(sdate)))
  return(sequence)
}

path <- '/esarchive/exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/cmip6-dcppA-hindcast_i1p1/DCPP/MOHC/HadGEM3-GC31-MM/dcppA-hindcast/r1i1p1f2/Omon/tos/gn/v20200417/$var$_Omon_HadGEM3-GC31-MM_dcppA-hindcast_s$sdate$-r1i1p1f2_gn_$chunk$.nc'

sdates <- c('2016', '2017', '2018')
chunks <- DatesSequence(sdates,
              inimonth = 1, finalmonth = 12, lag = 1, nyears = 3)

dat <- Start(dat = path,
             var = 'tos',
             sdate = sdates[1:2],
#             chunk = list(chunks[, 1], chunks[, 2]), #, '2018' = chunks[ ,3]),
             chunk = list('2016' = chunks[, 1], '2017' = chunks[, 2]), #, '2018' = chunks[ ,3]),
#             chunk = list(chunks[, 1], chunks[, 2], chunks[ ,3]),
#             chunk = values(chunks),  # [chunk = 3, sdate = 2]
             chunk_depends = 'sdate',
             time = 'all',
             i = indices(400:500),
             j = indices(600:700),
             time_across = 'chunk',
             merge_across_dims = TRUE,
             retrieve = TRUE,
             return_vars = list(time = 'sdate'))

