library(startR)

vari <- 'tos'
path_obs <- paste0('/esarchive/recon/ecmwf/era5/monthly_mean/', vari, '_f1h-r1440x721cds/$var$_$year$$month$.nc')
#path_obs <- paste0('/esarchive/recon/ecmwf/era5/monthly_mean/', vari, '/$var$_$year$$month$.nc')

#startdates_obs  <- paste0(c(1980)) 
lat_min <- -90
lat_max <- 90
lon_min <- 0
lon_max <- 359.99 #360
data_obs <- startR::Start(dat = path_obs,
                                   var = vari,
                                   year = '1980', #startdates_obs, 
                                   time = startR::indices(1:2), #'all', 
                                   lat = startR::values(list(lat_min, lat_max)),
                                   lon = startR::values(list(lon_min, lon_max)),
                                   month = 'all',
                                   month_depends = 'year', #ca fait quoi si je mets ici 'time' ?
                                   time_across = 'month', 
                                   merge_across_dims = TRUE,
                                   merge_across_dims_narm = TRUE,
                                    transform = startR::CDORemapper,
                                   transform_extra_cells = 2,
                                   transform_params = list(grid = 'r360x180', #'r100x50',
                                                           method = 'conservative',
#                                                           method = 'bil',
                                                           crop = F),
#                                                           crop = c(lon_min, lon_max, 
#                                                                    lat_min, lat_max)),
                                   transform_vars = c('lat', 'lon'),
                                   synonims = list(lon = c('lon', 'longitude'), 
                                                   lat = c('lat', 'latitude')),
                                   return_vars = list(lat='dat',
                                                      lon='dat',
                                                      time=c('year','month')),
                                   lon_reorder = startR::CircularSort(0, 360), 
                                   lat_reorder = startR::Sort(decreasing = T),
                                   retrieve = TRUE)

data_obs[1,1,1,1,20:25, 50:55]

# 'con'
        [,1]    [,2]     [,3]     [,4]     [,5]     [,6]
[1,] 272.517 272.058 271.7293 271.5604 271.4754       NA
[2,]      NA      NA 271.5100 271.4729 271.4608 271.4602
[3,]      NA      NA       NA       NA       NA       NA
[4,]      NA      NA       NA       NA       NA       NA
[5,]      NA      NA       NA       NA       NA       NA
[6,]      NA      NA       NA       NA       NA       NA

# 'bil'
         [,1]     [,2]     [,3]     [,4]     [,5]     [,6]
[1,] 272.6138 272.1070 271.7779 271.5868 271.4830 271.4609
[2,] 271.6091 271.5236 271.4954 271.4690 271.4603 271.4601
[3,] 271.4664 271.4602 271.4601       NA       NA 271.4601
[4,]       NA       NA       NA       NA       NA       NA
[5,]       NA       NA       NA       NA       NA       NA
[6,]       NA       NA       NA       NA       NA       NA

lon <- attr(data_obs, 'Variables')$dat1$lon
lat <- attr(data_obs, 'Variables')$dat1$lat
s2dv::PlotEquiMap(data_obs[1,1,1,1,,], lon = lon, lat = lat, 
                  bar_limits = c(270, 306),
                  toptitle = 'startR, conservative', fileout = 'startR_full_con.png')
s2dv::PlotEquiMap(data_obs[1,1,1,1,1:60,1:80], lon = lon[1:80], lat = lat[1:60], 
                  bar_limits = c(250, 300),
                  toptitle= 'startR, conservative', fileout = 'startR_reg_con.png')

#-----------------------------------------------------
library(maps)
library(s2dv)
# Clean memory
rm(list=ls())
gc()
vari <- 'tos'
#startdates_obs  <- paste0(c(1980), '0101')
obs_era <- list(name = 'era5',
                 path = file.path('/esarchive/recon/ecmwf/era5/monthly_mean', 
                                  '$VAR_NAME$_f1h-r1440x721cds/$VAR_NAME$_$YEAR$$MONTH$.nc'))
#obs_era <- list(name = 'era5',
#                 path = file.path('/esarchive/recon/ecmwf/era5/monthly_mean',
#                                  '$VAR_NAME$/$VAR_NAME$_$YEAR$$MONTH$.nc'))
data_obs2 <- Load(var = vari,
             exp = NULL,
             obs = list(obs_era),
             sdates= '19800101', #startdates_obs,
             nmember=1,
             leadtimemin = 1,
             leadtimemax = 1,
             output = 'lonlat',
             grid = 'r360x180', #'r100x50',
#             method = 'bilinear', 
             method = 'conservative',
             storefreq = 'monthly',
             nprocs= 1)

data_obs2$obs[1,1,1,1,20:25, 50:55]

# 'conversative'
       [,1]   [,2]   [,3]   [,4]   [,5]   [,6]
[1,] 272.52 272.06 271.73 271.56 271.48 271.46
[2,] 271.80 271.59 271.51 271.47 271.46 271.46
[3,] 271.48 271.46 271.46 271.46 271.46 271.46
[4,] 271.46     NA     NA     NA     NA     NA
[5,]     NA     NA     NA     NA     NA     NA
[6,]     NA     NA     NA     NA     NA     NA

# 'bilinear'
       [,1]   [,2]   [,3]   [,4]   [,5]   [,6]
[1,] 272.61 272.11 271.78 271.59 271.48 271.46
[2,] 271.61 271.52 271.50 271.47 271.46 271.46
[3,] 271.47 271.46 271.46     NA     NA 271.46
[4,]     NA     NA     NA     NA     NA     NA
[5,]     NA     NA     NA     NA     NA     NA
[6,]     NA     NA     NA     NA     NA     NA

lat2 <- data_obs2$lat
lon2 <- data_obs2$lon
s2dv::PlotEquiMap(data_obs2$obs[1,1,1,1,,], lon = lon2, lat = lat2, 
                  bar_limits = c(270, 306),
                  toptitle = 's2dv, conservative', fileout = 's2dv_full_con.png')
s2dv::PlotEquiMap(data_obs2$obs[1,1,1,1,20:25,50:55], lon = lon2[50:55], lat = lat2[20:25], toptitle= 's2dv, con', fileout = 's2dv_reg_con.png')


#---------------------------------------------------------
# Retrieve data then use CDORemap() to regrid.
# data_obs3 and data_obs4 are consistent, and same as data_obs.
# -> So, check CDORemap() and Load(). Why these two are not consistent?????
#---------------------------------------------------------
data_obs3 <- startR::Start(dat = path_obs,
                                   var = vari,
                                   year = '1980', #startdates_obs, 
                                   time = 'all',
                                   lat = values(list(lat_min, lat_max)),
                                   lon = values(list(lon_min, lon_max)),
                                   month = 'all',
                                   month_depends = 'year', #ca fait quoi si je mets ici 'time' ?
                                   time_across = 'month',
                                   merge_across_dims = TRUE,
                                   merge_across_dims_narm = TRUE,
#                                    transform = startR::CDORemapper,
#                                   transform_extra_cells = 2,
#                                   transform_params = list(grid = 'r360x180',
#                                                           method = 'conservative',
##                                                           method = 'bil',
#                                                           crop = c(lon_min, lon_max,
#                                                                    lat_min, lat_max)),
#                                   transform_vars = c('lat', 'lon'),
                                   synonims = list(lon = c('lon', 'longitude'),
                                                   lat = c('lat', 'latitude')),
                                   return_vars = list(lat='dat',
                                                      lon='dat',
                                                      time=c('year','month')),
                                   lon_reorder = CircularSort(0, 360),
                                   lat_reorder = Sort(decreasing = T),
                                   retrieve = TRUE)

lon3 <- attr(data_obs3, 'Variables')$dat1$lon
lat3 <- attr(data_obs3, 'Variables')$dat1$lat
res3 <- s2dverification::CDORemap(data_obs3, lon3, lat3, grid = 'r360x180', method = 'con', crop = FALSE)

res3$data_array[1,1,1,1,156:161, 50:55]
# -> same as data_obs

s2dv::PlotEquiMap(res3$data_array[1,1,1,1,,], lon = res3$lon, lat = res3$lat, 
                  bar_limits = c(270, 300),
                  toptitle= 'startR, CDORemap, conservative', fileout = 'startR_CDORemap_full_con.png')
s2dv::PlotEquiMap(res3$data_array[1,1,1,1,1:60,1:80], lon = res3$lon[1:80], lat = res3$lat[1:60],
                  bar_limits = c(270, 300),
                  toptitle= 'startR, conservative', fileout = 'startR_CDORemap_reg_con.png')

#------------------------------
data_obs4 <- s2dv::Load(var = vari,
             exp = NULL,
             obs = list(obs_era),
             sdates= '19800101', #startdates_obs,
             nmember=1,
             leadtimemin = 1,
             leadtimemax = 1,
             output = 'lonlat',
#             grid = 'r360x180',
##             method = 'bilinear', 
#             method = 'conservative',
             storefreq = 'monthly',
             nprocs= 1)

lon4 <- data_obs4$lon
lat4 <- data_obs4$lat
res4 <- CDORemap(data_obs4$obs, lon4, lat4, grid = 'r360x180', method = 'con', crop = FALSE)

res4$data_array[1,1,1,1,156:161, 50:55]

