library(startR)
# sdate 1990 tiene diferente version 
# v20200101 para 1962 1981
# v20200731 para 1990
fixed_repo <- '/esarchive/exp/cesm1-1-cam5-cmip5/cmip6-dcppA-hindcast_i1p1/original_files/cmorfiles/DCPP/NCAR/CESM1-1-CAM5-CMIP5/dcppA-hindcast/'
#cmipmodel = 'cesm1-1-cam5-cmip5'
vari <- 'msftmz'
mod <- 'Omon'
grid <- 'gn'
#fl = 'cmorfiles'
membs <- c('r1i1p1f1','r2i1p1f1')
#,'r3i1p1f1','r4i1p1f1','r5i1p1f1','r6i1p1f1','r7i1p1f1','r8i1p1f1','r9i1p1f1','r10i1p1f1')
#membs = c('r1i1p1f1')
#nmemb=10

repos <- paste0(fixed_repo, '/$memb$/', mod, '/$var$/', grid, 
                '/$version$/$var$_', mod, 
                '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s$sdate$-$memb$_', grid, '_$chunk$.nc')

data1 <- Start(dat = repos,
             var = vari,
             memb = membs,
             sdate = c('1962','1981', '1990'), #dim = c(sdate = 3, version = 1)),
             chunk = indices(1),
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             version = list('v20200731', 'v20200731', 'v20200101'), #version,
             version_depends = 'sdate',
             #sdate_depends = 'version',
             #chunk = 'all',
             chunk_depends = 'sdate',
             chunk_depends = 'version',
             version_depends = 'chunk',
             #time_across = 'chunk',
             #merge_across_dims = TRUE,
             return_vars = list(time = 'sdate', lev=NULL, lat=NULL),
             path_glob_permissive = 2,
             retrieve = TRUE)

dim(data1)
    dat     var    memb   sdate   chunk    time   basin     lev     lat version 
      1       1       2       3       1      10       1      61       4       1 

data1[1,1,1,,1,1,1,1,1,]
[1] 919370240 923862720 974687552
data1[1,1,2,,1,1,1,1,1,]
[1]        NA 580559296        NA

data2 <- Start(dat = repos,
             var = vari,
             memb = membs,
             sdate = c('1962','1981', '1990'), #dim = c(sdate = 3, version = 1)),
             chunk = indices(1),
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             version = list(c('v20200731', 'v20200101'), 
                            c('v20200731', 'v20200731'),
                            c('v20200101', 'v20200731')), #version,  
#             version = list('v20200731', 'v20200731', 'v20200101'), #version,
             version_depends = 'sdate',
             #sdate_depends = 'version',
             #chunk = 'all',
             chunk_depends = 'sdate',
             chunk_depends = 'version',
             version_depends = 'chunk',
             #time_across = 'chunk',
             #merge_across_dims = TRUE,
             return_vars = list(time = 'sdate', lev=NULL, lat=NULL),
             path_glob_permissive = 2,
             retrieve = TRUE)

dim(data2)
    dat     var    memb   sdate   chunk    time   basin     lev     lat version 
      1       1       2       3       1      10       1      61       4       2 

data2[1,1,1,,1,1,1,1,1,]
          [,1]      [,2]
[1,] 919370240        NA
[2,] 923862720 923862720
[3,] 974687552        NA

data2[1,1,2,,1,1,1,1,1,]
          [,1]       [,2]
[1,]        NA  549170048
[2,] 580559296  580559296
[3,]        NA 1250387968

#---------------------------------------------
#Check the data
fixed_repo <- '/esarchive/exp/cesm1-1-cam5-cmip5/cmip6-dcppA-hindcast_i1p1/original_files/cmorfiles/DCPP/NCAR/CESM1-1-CAM5-CMIP5/dcppA-hindcast/'
memb1 <- 'r1i1p1f1'
memb2 <- 'r2i1p1f1'

repos1 <- paste0(fixed_repo, memb1, '/',
                 mod, '/$var$/', grid, '/v20200731/$var$_', mod, 
                '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1962-', memb1, '_', grid,'_196211-197212.nc')

data_1962_memb1 <- Start(dat = repos1,
             var = vari,
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             return_vars = list(time = NULL, lev=NULL, lat=NULL),
             retrieve = TRUE)
data_1962_memb1[1,1,1,1,1,1]
[1] 919370240

repos2 <- paste0(fixed_repo, memb2, '/', 
                 mod, '/$var$/', grid, '/v20200101/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1962-', memb2, '_', grid,'_196211-197212.nc')
data_1962_memb2 <- Start(dat = repos2,
             var = vari,
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             return_vars = list(time = NULL, lev=NULL, lat=NULL),
             retrieve = TRUE)
data_1962_memb2[1,1,1,1,1,1]
[1] 549170048

## 1981
repos1 <- paste0(fixed_repo, memb1, '/',
                 mod, '/$var$/', grid, '/v20200731/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1981-', 
                 memb1, '_', grid,'_198111-199112.nc')

data_1981_memb1 <- Start(dat = repos1,
             var = vari,
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             return_vars = list(time = NULL, lev=NULL, lat=NULL),
             retrieve = TRUE)
data_1981_memb1[1,1,1,1,1,1]
[1] 923862720

repos2 <- paste0(fixed_repo, memb2, '/',
                 mod, '/$var$/', grid, '/v20200731/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1981-',
                 memb2, '_', grid,'_198111-199112.nc')

data_1981_memb2 <- Start(dat = repos2,
             var = vari,
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             return_vars = list(time = NULL, lev=NULL, lat=NULL),
             retrieve = TRUE)
data_1981_memb2[1,1,1,1,1,1]
[1] 580559296


## 1990
repos1 <- paste0(fixed_repo, memb1, '/',
                 mod, '/$var$/', grid, '/v20200101/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1990-',
                 memb1, '_', grid,'_199011-200012.nc')

data_1990_memb1 <- Start(dat = repos1,
             var = vari,
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             return_vars = list(time = NULL, lev=NULL, lat=NULL),
             retrieve = TRUE)
data_1990_memb1[1,1,1,1,1,1]
[1] 974687552

repos2 <- paste0(fixed_repo, memb2, '/',
                 mod, '/$var$/', grid, '/v20200731/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1990-',
                 memb2, '_', grid,'_199011-200012.nc')

data_1990_memb2 <- Start(dat = repos2,
             var = vari,
             time = indices(3:12),
             basin = indices(1),
             lev = 'all',
             lat = indices(1:4),
             return_vars = list(time = NULL, lev=NULL, lat=NULL),
             retrieve = TRUE)
data_1990_memb2[1,1,1,1,1,1]
[1] 1250387968


#====================================================================
# multiStart
source("/esarchive/scratch/nperez/git/startR/R/multiStart.R")
source("/esarchive/scratch/nperez/git/startR/R/zzz.R")
.warning <- startR:::.warning()

fixed_repo <- '/esarchive/exp/cesm1-1-cam5-cmip5/cmip6-dcppA-hindcast_i1p1/original_files/cmorfiles/DCPP/NCAR/CESM1-1-CAM5-CMIP5/dcppA-hindcast/'
vari <- 'msftmz'
mod <- 'Omon'
grid <- 'gn'
#fl = 'cmorfiles'
membs <- c('r1i1p1f1','r2i1p1f1')
#,'r3i1p1f1','r4i1p1f1','r5i1p1f1','r6i1p1f1','r7i1p1f1','r8i1p1f1','r9i1p1f1','r10i1p1f1')
#membs = c('r1i1p1f1')
#nmemb=10

#------------------------------------------------------------------------------
# Try 1
repos1 <- paste0(fixed_repo, '$memb$/', mod, '/$var$/', grid,
                 '/$version$/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s$sdate$-$memb$_', grid, '_$chunk$.nc')

repos <- list(list(name = 's1962', path = repos1),
              list(name = 's1981', path = repos1),
              list(name = 's1990', path = repos1))

res <- multiStart(dat = repos,
                  var = vari,
                  memb = membs[1],
                  version = list(list(name = 's1962', version = 'v20200731'),
                                 list(name = 's1981',  version = 'v20200731'),
                                 list(name = 's1990',  version = 'v20200101')),
                  sdate = list(list(name = 's1962', sdate = '1962'), 
                               list(name = 's1981',  sdate = '1981'), #indices(8)),
                               list(name = 's1990', sdate = '1990')),
                  time = indices(3:12),
                  basin = indices(1),
                  lev = 'all',
                  lat = indices(1:4),
                  chunk = 'all',
#                  chunk_depends = 'sdate',
#                  chunk_depends = 'version',
                  #time_across = 'chunk',
                  #merge_across_dims = TRUE,
                  #return_vars = list(time = NULL, lev=NULL, lat=NULL),
                  retrieve = TRUE)

res[,1,1,1,1,1,1,1,1,1]
[1] 919370240 923862720 974687552

#------------------------------------------------------------------------------
# Try 2
repos1 <- paste0(fixed_repo, 'r1i1f1p1/', mod, '/$var$/', grid,
                 '/$version$/$var$_', mod, 
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s$sdate$-$memb$_', grid, '_$chunk$.nc')
repos2 <- paste0(fixed_repo, 'r2i1p1f1/', mod, '/$var$/', grid,
                 '/v20200731/$var$_', mod,
                 '_CESM1-1-CAM5-CMIP5_dcppA-hindcast_s1981-$memb$_', grid, '_$chunk$.nc')

repos <- list(list(name = 'memb1', path = repos1),
              list(name = 'memb2', path = repos2))

res <- multiStart(dat = repos,
                  var = vari,
#                  memb = membs,
                  version = list(list(name = 'memb1', version = 'v20200731'),
                                 list(name = 'memb2',  version = 'v20200101')),
                  sdate = list(list(name = 's1962', sdate = '1962'),
                               list(name = 's1981',  sdate = '1981'), #indices(8)),
                               list(name = 's1990', sdate = '1990')),
                  time = indices(3:12),
                  basin = indices(1),
                  lev = 'all',
                  lat = indices(1:4),
                  chunk = 'all',
#                  chunk_depends = 'sdate',
#                  chunk_depends = 'version',
                  #time_across = 'chunk',
                  #merge_across_dims = TRUE,
                  #return_vars = list(time = NULL, lev=NULL, lat=NULL),
                  retrieve = TRUE)


