  library(startR)

  repos <- "/esarchive/exp/ecmwf/system5_m1/monthly_mean/tas_f6h/$var$_$sdate$.nc"

  var <- 'tas'
  sdate <- c(paste0('2017', '0', c(1:9), '01'), paste0('2017', c(10:12), '01'))
  #sdate <- '20170101'
  #exp <- list('r4i1p1', 'r5i1p1')
# Define a region
lons.min <- 1
lons.max <- 10
lats.min <- 0
lats.max <- -20

  data <- Start(dat = repos,
                var = var,
#                sdate = (list(sdate[1], sdate[length(sdate)])),
                sdate = indices(1:6), #values(list('20170101')),
                ensemble = indices(2:4),
                time = 'all',
                latitude = values(list(lats.min, lats.max)),
                latitude_reorder = Sort(),
                longitude = values(list(lons.min, lons.max)),
                #longitude_reorder = CircularSort(0, 360),
#                latitude = indices(1:40),
#                longitude = indices(1:49),
                return_vars = list(longitude = 'dat', latitude = 'dat'),
                retrieve = FALSE
               )

 fun <- function(x) {
              apply(x, c(which(names(dim(x)) != 'ensemble')), mean)
            }

  step <- Step(fun, target_dims = c('ensemble',  'time'),
                    output_dims = c( 'time'))

  wf <- AddStep(data, step)

  res <- Compute(wf,
                 #chunks = list(sdate = 4))
                 chunks = list(latitude = 2, longitude = 2))
