library(startR)

## Origin longitude in file: [0:360]
path_exp <- '/esarchive/exp/ecmwf/system5_m1/daily_mean/$var$_f6h/$var$_$sdate$.nc'
variable <- 'psl'

## Origin longitude in file: [-180:180]
path_exp <- '/esarchive/recon/ecmwf/era5/original_files/reorder/daily_mean/$var$/$var$_$sdate$.nc'
variable <- 'tas'


lons.min <- -10
lons.max <- -20
lats.min <- 10
lats.max <- 20

hcst <- Start(dat = list(list(path=path_exp)),
              var = variable,
              #ensemble = 'all',
              sdate = '199201', #'19821201',
              time = indices(3:4),            
              latitude = values(list(lats.min, lats.max)),
#              latitude = values(c(lats.min:lats.max)),
              latitude_reorder = Sort(),
              longitude = values(list(lons.min, lons.max)),
#              longitude = values(c(lons.min:lons.max)),
              longitude_reorder = CircularSort(0, 360),
#              longitude_reorder = CircularSort(-180, 180),
              transform = CDORemapper,
#apply_indices_after_transform = T,
              transform_params = list(grid ='r360x181',
                                      method = 'con',
                                      crop = c(lons.min,lons.max,
                                               lats.min,lats.max)),
              transform_vars = c('longitude', 'latitude'),
              transform_extra_cells = 2,
              synonims = list(latitude=c('lat','latitude'),
                              longitude=c('lon','longitude')),
                              #member=c('ensemble','realization')),
              return_vars = list(latitude = 'dat',
                                 longitude = 'dat',
                                 time = NULL),
              retrieve = F)

 as.vector(attr(hcst, 'Variables')$dat1$latitude)
 as.vector(attr(hcst, 'Variables')$dat1$longitude)


#works well. WHat is x??? indices or value???
#it returns the value following the range of [start:end]
#> x <- c(-2,-1,0,1)
#> start <- 0
#> end <- 360
#> x <- do.call(sort, c(list((x - start) %% (end - start) + start,index.return = TRUE),list()))
#> x
#$x
#[1]   0   1 358 359
#
#$ix
#[1] 3 4 1 2

CircularSort <- function(start, end, ...) {
  params <- list(...)
  f <- "function (x) {
    start <- START
    end <- END
    dim_bk <- dim(x)
    x <- do.call(sort, c(list((x - start) %% (end - start) + start, 
                              index.return = TRUE),
                         PARAMS))
    dim(x$x) <- dim_bk
    dim(x$ix) <- dim_bk
    x
  }"
  f <- gsub("START", deparse(start), f)
  f <- gsub("END", deparse(end), f)
  f <- gsub("PARAMS", deparse(params), f)
  r <- eval(parse(text = f))
  attr(r, 'circular') <- TRUE
  r
}



Sort <- function(...) {
  params <- list(...)
  f <- "function(x) {
    dim_bk <- dim(x)
    x <- do.call(sort, c(list(x, index.return = TRUE),
                         PARAMS))
    dim(x$x) <- dim_bk
    dim(x$ix) <- dim_bk
    x
  }"
  f <- gsub("PARAMS", deparse(params), f)
  r <- eval(parse(text = f))
  attr(r, 'circular') <- FALSE
  r
}




#==================Jaume================
# NO transformation

lats.min <- 10
lats.max <- 20
lons.min <- 20  #350
lons.max <- -10
# ori lon: [0, 360]
obs_path <- '/esarchive/recon/ecmwf/era5/monthly_mean/$var$_f1h/$var$_$sdate$.nc'
var_name <- 'tas'
sdate <- '201811'
res <- Start(dat = obs_path,
             var = var_name,
             sdate = c('201811'),
             time = indices(1),
             latitude = values(list(lats.min, lats.max)),
#             latitude = values(c(10, 14, 20, 13, 12)),
             latitude_reorder = Sort(),
#             longitude = values(c(lons.min:lons.max)),
             longitude = values(list(lons.min, lons.max)),
#             longitude = indices(c(20:60)),
             longitude_reorder = CircularSort(0, 360),
             longitude_reorder = CircularSort(-180, 180),
#             longitude_reorder = Sort(decreasing = T),
             synonims = list(longitude = c('lon', 'longitude'),
                             latitude = c('lat', 'latitude')),
             return_vars = list(time = NULL,
                                latitude = 'dat',
                                longitude = 'dat'),
             retrieve = F)

as.vector(attr(res, 'Variables')$dat1$longitude) 
as.vector(attr(res, 'Variables')$dat1$latitude)
