###### Input: 
# yTref <- 1980 # the start year of reference
# Tref <- dim(nmemb,total_ndays)
# yTemp <- 1961
# Temp <- dim(nmemb,total_ndays)

###### Output:
# HMD <- Heat magnitude days for all the members

hmd_x <- function (yTref, Tref, yTemp, Temp) 
{
  # T30ymax <- NULL
  # Instead of the above three lines: make an error if the time dimenation is not divisible by 365. It will save computational time
  
  
  # Tref <- cut366thDay(yTref, (yTref + 31), Tref)
  # yendTemp <- (trunc(length(Temp)/365) - 1)
  # Temp <- cut366thDay(yTemp, (yTemp + yendTemp), Temp)
  
  # Tref should be of two dimension: first: member, second: days along each year from 1980 to 2011
  
  # load('/home/Earth/bsolaraj/Documents/R/DecadalScript/JRC/DailyData/NCAR_DPLE_Europe.RData')
  # a_exp <- drop(data_exp)
  # dim(a_exp)
  # tasmax <- aperm(1,3,2,4,5)
  # n_days <- (54*365)
  #dim(tasmax) <- c(,ndays,,)
  # tasmax_test <- tasmax[,,10,10]
  
  # Temp <- tasmax_test
  # Tref <- tasmax_test[,7300:18979] # Be careful while choosing days, as it is dependent on the starting year of Temp
  # yTref <- 1980
  # t1 <- yTref
  # t2 <- (yTref + 31)
  # t1ref <- t1ref
  # t1ref <- yTref+1
  # t2ref <- yTref + 30
  # Ti <- Tref
  # thresh.lev <- 90
  # nday <- 15
  
  threshold <- mvThreshold_x(yTref, (yTref + 31), (yTref + 1), 
                           (yTref + 30), Tref, 90, 15)
  ## Percentile computation
  threshold25 <- mvThreshold_x(yTref, (yTref + 31), (yTref + 1), 
                           (yTref + 30), Tref, 25, 15)
  threshold75 <- mvThreshold_x(yTref, (yTref + 31), (yTref + 1), 
                             (yTref + 30), Tref, 75, 15)  
  ####
  # for (ij in seq((365 + 1), (length(Tref) - 365), 365)) {
  #   Tymax <- max(Tref[ij:(ij + 364)], na.rm = TRUE)
  #   T30ymax <- c(T30ymax, Tymax)
  # }
  # T30y25p <- quantile(T30ymax, 0.25, na.rm = TRUE)
  # T30y75p <- quantile(T30ymax, 0.75, na.rm = TRUE)
  T25p <- threshold25
  T75p <- threshold75
  iqr30y <- (T75p - T25p)
  nyears <- as.integer(length(Temp[1,])/365)
  hwmid <- hwmidFun_hmd_x(nyears, Temp, threshold, T25p, iqr30y)
  # hwmid <- hwmid_temp[,,1]
  return(hwmid)
  # return(list(hwmid = hwmid, thr = threshold[1:365], T25p = T25p, 
  #             T75p = T75p))
}

# mvThreshold

# Ti <- two dimension: Member, days
mvThreshold_x <- function(t1, t2, t1ref, t2ref, Ti, thresh.lev, nday) {
  
  timey <- c(t1:t2)
  lt <- length(timey) * 365
  refper.ind <- which(timey == t1ref)
  refper.ind1 <- ((refper.ind - 1) * 365 + 1)
  refper.ind2 <- ((refper.ind + 29) * 365)
  
  T2 <- Ti[,(refper.ind1 - nday):(refper.ind2 + nday)]
  
  timeyref <- c(t1ref:t2ref)
  
  Thresh <- c(1:365)
  
  for (i in (1 + nday):(365 + nday)) {
    
    # si parte da 3 e si finisce a 367 perche' abbiamo aggiunto 2 giorni
    # a destra e a sinistra nella serie di temperature T2 quindi T2 ha
    # lunghezza 365*30+4 gg
    
    i30 <- seq(i, (29 * 365 + i), 365)
    
    t5days<-T2[,i30]
    for (j in 1:nday) t5days <- c(t5days, T2[,i30 - j], T2[,i30 + j])
    
    a <- quantile(t5days, probs = seq(0, 1, 0.1), na.rm = TRUE, names = FALSE, type = 8)
    b <- quantile(t5days, probs = seq(0, 1, 0.01), na.rm = TRUE, names = FALSE, type = 8)
    
    # if (thresh.lev == 10) Thresh[(i - nday)] <- a[2]
    
    if (thresh.lev == 90) Thresh[(i - nday)] <- a[10]
    
    # if (thresh.lev == 5) Thresh[(i - nday)] <- b[6]
    # 
    if (thresh.lev == 75) Thresh[(i - nday)] <- b[76]
    # 
    # if (thresh.lev == 50) Thresh[(i - nday)] <- b[51]
    # 
    if (thresh.lev == 25) Thresh[(i - nday)] <- b[26]
    # 
    # if (thresh.lev == 95) Thresh[(i - nday)] <- b[96]
    # 
    # if (thresh.lev == 2) Thresh[(i - nday)] <- b[3]
    # 
    # if (thresh.lev == 98) Thresh[(i - nday)] <- b[99]
    
  } # end of for 'i' loop.
  
  return(Thresh)
  
}


# HMD Computation
hwmidFun_hmd_x <- function (nyears, Ta, threshold, T25p, iqr30y) 
{
  nmemb <- length(Ta[,1])
  hw.scale_final <- array(NA, dim = c(nmemb,nyears,3))
  
  for (i in 1:nmemb) {
    Ti <- Ta[i,]
    
    hw.scale <- matrix(-111, nyears, 3)
    hw.scale[1:nyears, 1:3] <- 0
    k <- 0
    for (year in 1:nyears) {
      Ts <- Ti[(k * 365 + 1):((k + 1) * 365)]
      indTs <- which(is.na(Ts))
      Ts[indTs] <- -999.9
      hw <- hwyear(Ts, threshold[1:365], 3)
      phw3 <- c(1:length(hw[, 1]))
      phw3[1:length(hw[, 1])] <- 0
      if (hw[1, 1] > 0) {
        for (id in 1:length(hw[, 1])) {
          hwd <- hw[id, 1]
          hwt <- hw[id, 5]
          thw <- Ts[hwt:(hwt + hwd - 1)]
          t25p_select <- T25p[hwt:(hwt + hwd - 1)]
          i30y <- iqr30y[hwt:(hwt + hwd - 1)]
          for (ik in 1:hwd) {
            thwN <- (thw[ik] - t25p_select[ik])
            if (thwN > 0) {
              fvalue <- (thwN/i30y[ik])
              phw3[id] <- (phw3[id] + fvalue)
            }
          }
        }
      }
      
      ### Accumulation prior to the harvest month
      har_day <- 242
      prior_har_day <- 242-90
      if(sum(hw[,5] < har_day & hw[,5] > prior_har_day)>=1) {
        indtime <- which(hw[,5] < har_day & hw[,5] > prior_har_day)
        hw.time <- hw[indtime, 5]
        hw.duration <- hw[indtime, 1]
        hw.scale[year, 1] <- sum(phw3[indtime])
        hw.scale[year, 2] <- sum(hw.duration)  # number of days with heatwave
        hw.scale[year, 3] <- length(hw.time)  # number of heatwave
      }
      k <- k + 1
    }
    hw.scale_final[i,,] <- hw.scale
  }

  return(hw.scale_final)
}
    # if (max(phw3) > 0) {
    #   indtime <- which(phw3 == max(phw3))
    #   if (length(indtime) > 1) 
    #     indtime <- indtime[1]
    #   hw.time <- hw[indtime, 5]
    #   hw.duration <- hw[indtime, 1]
    #   hw.scale[year, 1] <- max(phw3)
    #   hw.scale[year, 2] <- hw.duration
    #   hw.scale[year, 3] <- hw.time
    # }

# Final output: Index(HMD); Total number of days with heatwave; Number of heatwave

hwyear <- function(Ti, threshold, nd) {
  
  index <- Ti > threshold
  
  temp.ind <- index * Ti
  
  time <- c(1:length(Ti))
  
  v <- time * index
  z1 <- which(v == 0)
  
  HWF<-0
  HWtime <- HWD <- HWI <- HWInd <- HWIndT <- HW <- NULL
  
  if (sum(index) >= 365) {
    
    HWD <- sum(index)
    HWI <- sum(Ti - threshold)
    HWsort <- sort((Ti - threshold), decreasing = TRUE)
    HWInd <- sum(HWsort[ 1:nd ])
    HWsortT <- sort(Ti, decreasing = TRUE)
    HWIndT <- sum(HWsortT[ 1:nd ])
    HWtime <- 1
    
  } # end of if 'sum of index >= 122' stmts.
  
  if (length(z1) == 1) {
    
    if (z1[1]>nd) {
      
      HWD0 <- sum(index[ 1:(z1[1] - 1) ])
      
      HWF <- HWF + 1
      HWtime[HWF] <- 1
      
      HWD[ HWF ] <- HWD0
      
      HWI[ HWF ] <- sum(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ])
      HWsort <- sort((Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1)] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ]), decreasing = TRUE)
      
      HWInd[ HWF ] <- sum(HWsort[ 1:nd ])
      HWsortT <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1)], decreasing = TRUE)
      HWIndT[ HWF ] <- sum(HWsortT[ 1:nd ])
      
    } # end of if 'z1[1] == 1' stmts.
    
    if (max(z1) < length(time) && sum(index[ max(z1):length(time) ]) >= nd) {
      
      HWF <- HWF + 1
      
      HWD[ HWF ] <- sum(index[ max(z1):length(time) ])
      
      HWtime[ HWF ] <- max(z1) + 1
      
      HWI[ HWF ] <- sum(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ])
      
      HWsort <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ], decreasing = TRUE)
      
      HWInd[ HWF ] <- sum(HWsort[ 1:nd ])
      HWsortT <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ], decreasing = TRUE)
      HWIndT[ HWF ] <- sum(HWsortT[ 1:nd ])
      
    }
    
  } # end of if 'length of z1 = 1' stmts.
  
  if (length(z1)>1) {
    
    if (z1[1]>nd) {
      
      HWD0 <- sum(index[ 1:(z1[1] - 1) ])
      HWF <- HWF + 1
      
      HWtime[ HWF ] <- 1
      HWD[ HWF ] <- HWD0
      HWI[ HWF ] <- sum(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ])
      
      HWsort <- sort((Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ]), decreasing = TRUE)
      HWInd[ HWF ] <- sum(HWsort[ 1:nd ])
      
      HWsortT <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ], decreasing = TRUE)
      HWIndT[ HWF ] <-sum(HWsortT[ 1:nd ])
      
    } # end of if 'z1[1] > nd' stmts.
    
    for (i in 1:(length(z1)-1)) {
      
      HWD0 <- sum(index[ (z1[i] + 1):(z1[i + 1] - 1) ])
      
      if (HWD0>=nd) {
        
        HWF <- HWF + 1
        HWtime[ HWF ] <- (z1[i] + 1)
        
        HWD[ HWF ] <- HWD0
        
        HWI[ HWF ] <- sum(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ])
        HWsort <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1)], decreasing = TRUE)
        
        HWInd[ HWF ] <- sum(HWsort[ 1:nd ])
        HWsortT <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ], decreasing = TRUE)
        HWIndT[ HWF ] <- sum(HWsortT[ 1:nd ])
        
      } # end of if 'HWD0 >= nd' stmts.
      
    } # end of for 'i' loop.
    
    if (max(z1) < length(time) && sum(index[ max(z1):length(time) ]) >= nd) {
      
      HWF <-HWF+1
      HWD[ HWF ] <- sum(index[ max(z1):length(time) ])
      
      HWtime[ HWF ] <- max(z1) + 1
      
      HWI[ HWF ] <- sum(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ])
      HWsort <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ] - threshold[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ], decreasing = TRUE)
      
      HWInd[ HWF ] <- sum(HWsort[ 1:nd ])
      HWsortT <- sort(Ti[ (HWtime[HWF]):(HWtime[HWF] + HWD[HWF] - 1) ], decreasing = TRUE)
      HWIndT[ HWF ] <- sum(HWsortT[ 1:nd ])
      
    }
    
  } # end of if length of z > 1 stmts.
  
  HW <- c(HWD, HWI, HWInd, HWIndT, HWtime)
  
  if (length(HWD)>0) dim(HW)<-c(length(HWD),5)
  else if (length(HWD)==0) {
    
    HW<-c(-1111,-1111,-1111,-1111,-1111)
    dim(HW)<-c(1,5)
    
  } # end of if else 'length of HWD' stmts.
  
  return(HW)
  
} # end of 'hwyear' function.
