library(startR)
library(s2dverification)
path_exp <- paste0('/esarchive/exp/ncar/cesm-dple/daily_mean/',
                   '$var$_f24h/$var$_$sdate$.nc')
variable <- 'tasmax'
y1 <- 1961
y2 <- 2014
monini <- '11'
sdates_exp<-paste0(y1:y2,monini,'01')
nmemb <- 2

lats.min=25
lats.max=30
lons.min=40
lons.max=44

# shrink the size
#lats.min=28
#lats.max=30
#lons.min=42
#lons.max=44

start <- Sys.time()
data1 <- Start(dat = list(list(path=path_exp)),
                  var = variable,
                  member = indices(1:nmemb),
                  time = indices(62:426),
                  sdate = sdates_exp,
                  latitude = values(list(lats.min, lats.max)),
                  longitude = values(list(lons.min, lons.max)),
                  longitude_reorder = CircularSort(0, 360),
                  synonims = list(latitude=c('lat','latitude'),
                                  longitude=c('lon','longitude'),
                                  member=c('ensemble','realization')),
                  num_procs = 1,
                  return_vars = list(latitude = NULL,
                                     longitude = NULL,
                                     time = 'dat'),
                  retrieve = T)
finish <- Sys.time()
print(finish - start)

