library(startR)

  repo_exp <- paste0('/esarchive/exp/ecmwf/system4_m1/monthly_mean/$var$_f6h/$var$_$sdate$.nc')
  sdate <- '20120501'

  system4 <- Start(dat = repo_exp,
                   var = 'uas',
                   ensemble = 'all',
                   sdate = sdate,
                   time = 'all',
                   latitude = 'first', 
                   latitude_reorder = Sort(),
                   longitude = 'first',
                   return_vars = list(latitude = NULL,
                                      longitude = NULL,
                                      time = c('sdate')))

  dates <- attr(system4, 'Variables')$common$time
  print(dates)

