library(multiApply)
library(easyVerification)
library(startR)
library(s2dverification)
################################################################################################
########################################## PARAMETERS ##########################################
################################################################################################
retrieve = FALSE
## MODEL, REANALYSIS AND VARIABLE
models = c('EC-Earth','NCAR')
reanalyses = c('JRA-55')
variables = c('tas','tos')
model = models[1]
reanalysis = reanalyses[1]
variable = variables[1]## REGION
#grid =
lats_min = 0
lats_max = 14
lons_min = 0
lons_max = 28
## PERIOD
year_first = 2000
year_end = 2000
sdates = paste0(year_first:year_end)
path_exp = '/esarchive/exp/ecearth/a1ua/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/$member$/Amon/$var$/gr/v20190713/$var$_Amon_*_s$sdate$-$member$_gr_$leadyear$.nc'

data_exp = Start(dataset = path_exp,
                 var = variable,
                 sdate = sdates,
                 month = 'all',
                 lat = values(list(lats_min, lats_max)),
                 lon = values(list(lons_min, lons_max)),
                 leadyear = 'all',
                 member = 'all',
#                 lead_year_depends = 'sdate',
#                 month_across = 'lead_year',
                 synonims = list(month = c('month','time'), 
                                 lon = c('lon', 'longitude'), 
                                 lat = c('lat', 'latitude')),
                 return_vars = list(lat = 'dataset', lon = 'dataset'),
                 # lat_reorder = Sort(),
                 num_procs = 1, retrieve = retrieve)

################################################################################################
###################################### ONE INPUTS, ONE OUTPUTS #################################
################################################################################################# 
attr(data_exp,'Variables')
attr(data_exp,'Dimensions')
# as.vector(attr(data_exp,'Variables')$dat1[['lat']])

fun <- function(x) {
y = apply(x,2,mean)
# print(dim(x))
# as.vector(attr(x,'Variables')$dat1[['lon']])
# as.vector(attr(x,'Variables')$dat1[['lat']])
# mean = multiApply::Apply(data = x, target_dims = c('month','member'), FUN = mean)
return(y)}

step <- Step(fun = fun,
# use_libraries = c('multiApply'),
# use_attributes = list(data_exp = c('Variables', 'Dimensions')),
target_dims = c('month','member'),
output_dims = c('member'))

wf = AddStep(inputs = data_exp, step_fun = step)



# FAT
  res <- Compute(wf,
chunks = list(lead_year = 1),
#                 chunks = list(lat = 2,
#                               lon = 1),#$output1
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = 'fat',
                                queue_type = 'slurm',
                                cores_per_job = 2,
                                job_wallclock = '00:30:00',
                                max_jobs = 4,
                                bidirectional = TRUE
                 ),
                 ecflow_suite_dir = '/home/Earth/aho/startR_local/'
#                 wait = TRUE
         )


# Power9
  res <- Compute(wf,
                 chunks = list(lat = 1,
                               lon = 2),#$output1
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = queue_host,
                                queue_type = 'slurm',
                                temp_dir = temp_dir,
                                #lib_dir = '/gpfs/projects/bsc32/share/R_libs/3.5/',
                                r_module = 'R/3.5.0-foss-2018b',
                                #r_module = 'startR/0.1.2-foss-2018b-R-3.5.0',
                                job_wallclock = '01:00:00',
                                cores_per_job = 4,
                                max_jobs = 4,
                                bidirectional = FALSE,
                                polling_period = 50
                               ),
                # ecflow_suite_dir = ecflow_suite_dir,
                ecflow_suite_dir = '/esarchive/scratch/aho/ecFlow',
                 wait = TRUE
                 )  #$output1



# Locally
res <- Compute(workflow = wf,
chunks = list(lat = 2,lon = 2),
threads_load = 2,
threads_compute = 4)
