library(startR)

fcst.sdate.start <- "202002"
variable   <- "tas"
fcst.freq  <- "monthly_mean"
freq.hcst  <- "f6h"
obs.dir    <- "/esarchive/recon/ecmwf/era5/"
fcst.dir   <- "/esarchive/exp/ecmwf/system5c3s/" 
obs.path   <- "/esarchive/recon/ecmwf/era5/monthly_mean/tas_f1h/tas_$file_date$.nc"
fcst.path <- "/esarchive/exp/ecmwf/system5c3s/monthly_mean/tas_f6h/tas_$syear$01.nc"

#dates_file <- matrix(ncol = 2, nrow = 3,
#                     data = c("201702", "201802", "201902",
#                              "201703", "201803", "201903"))
dates_file <- "201702"

lats.min <- 80 #-90
lats.max <- 90
lons.min   <- 10
lons.max   <- 15

  obs <- Start(dat = obs.path,
               var = variable,
               file_date = dates_file,
               latitude = values(list(lats.min, lats.max)),
               latitude_reorder = Sort(decreasing =T),
               longitude = values(list(lons.min, lons.max)),
               longitude_reorder = CircularSort(0, 360),   #problema si no esta linea
               synonims = list(latitude=c('lat','latitude'),
                               longitude=c('lon','longitude')), 
               transform = CDORemapper,
               transform_params = list(
                 grid = 'r360x181',
                 method = 'con',
                 crop = c(lons.min,lons.max,lats.min,lats.max) #problema cuando no reorder
               ), 
               transform_vars = c('latitude', 'longitude'), 
               return_vars = list(latitude = 'dat',
                                  longitude = 'dat',
                                  time = 'file_date'),
               retrieve = F)
as.vector(attr(obs, 'Variables')$dat1$latitude)

