exp_path <- paste0('/esarchive/exp/ncep/cfs-v2/weekly_mean/s2s/$var$_f24h/',
                   '$var$_$sdate$.nc')

obs_path <- paste0("/esarchive/recon/ecmwf/era5/weekly_mean/",
          "$var$_f1h/$var$_$file_date$.nc")

hcst.sdates<-c( "19990104", "19990107", "19990111", "19990114", "19990118", "19990121", "19990125", "19990128", "20000104", "20000107", "20000111", "20000114",
"20000118", "20000121", "20000125", "20000128")

hcst.sdates<-c( "19990104", "19990107", "19990111")
var_name<-'tas'

exp1 <- Start(dat = exp_path, 
             var = var_name,
             sdate = hcst.sdates,   #YYYYMMDD
             time = indices(1:4),
             latitude =  indices(1:4),#values(list(lats.min, lats.max)),
             longitude = indices(1:4),#values(list(lons.min, lons.max)),
             ensemble='all',
             return_vars = list(lat = NULL,
                                lon = NULL,
                                 time = c('sdate')),
             synonims = list(latitude=c('lat','latitude'),
                             longitude=c('lon','longitude')), 
             retrieve = F)

dates <- attr(exp1, 'Variables')$common$time
file_date <- sapply(dates, format, '%Y%m%d')
dim(file_date) <- dim(dates)

obs1 <- Start(dat = obs_path, 
             var = var_name,
             file_date= file_date,   # dim('sdate','time') 
             latitude = indices(1:4),#values(list(lats.min, lats.max)),
             longitude = indices(1:4),#values(list(lons.min, lons.max)),
             return_vars = list(latitude = 'dat',
                                     longitude = 'dat',
                                     time = 'file_date'),
             split_multiselected_dims = TRUE,
             retrieve=F)


score_calc<-function(forecast,reference){
	em<- Apply(forecast,'ensemble',mean,na.rm=TRUE)[[1]]
	bias<-Apply(reference,c('sdate'),function(x) x-em)[[1]]
        dim(bias)<-c(length(bias))
      return(bias)
}

step <- Step(score_calc, 
             list(forecast = c('sdate','ensemble'),
                  reference = c('sdate')),
             list(bias = c('sdate')),
                 use_libraries = c('multiApply'))

wf <- AddStep(list(exp1,obs1), step)

res <- Compute(wf, chunks = list(time = 2))


#------test with Chou's function------------------
#-----------it works!!!-------------
wrap_cal2 <- function(obs, exp) {
# dim(exp) is (ensemble, sdate, time)
# dim(obs) is (sdate, time)

#print(dim(exp))
#print(dim(obs))
 bc <- multiApply::Apply(list(var_obs = obs, var_exp = exp),   
                         target_dims = list(c('sdate'),
                                            c('ensemble', 'sdate')),
             fun = CSTools:::.sbc)$output1
}

stepp <- Step(wrap_cal2,
             target_dims = list(c('sdate', 'time'),
                                c('ensemble', 'sdate', 'time')
                           ),
             output_dims = c('ensemble', 'sdate', 'time')
        )

wff <- AddStep(list(obs1, exp1), stepp)
res <- Compute(wff, chunks = list(longitude = 2))
#------------------------------
