repos <- paste0('/esarchive/exp/ecmwf/system4_m1/6hourly/',
                '$var$/$var$_$sdate$.nc')

system4 <- Start(dat = repos,
                 var = 'tas',
                 sdate = paste0(1981:1984, '1101'),
                 time = indices((30*4+1):(30*4+4)),
                 ensemble = 'all',
                 latitude = indices(1:10),
                 longitude = indices(1:10),
                 return_vars = list(latitude = NULL,
                                    longitude = NULL,
                                    time = c('sdate')))

repos <- paste0('/esnas/recon/ecmwf/erainterim/6hourly/',
                '$var$/$var$_$file_date$.nc')

dates <- attr(system4, 'Variables')$common$time
dates_file <- sort(unique(gsub('-', '', sapply(as.character(dates), substr, 1, 7))))

obs <-    Start(dat = repos,
                 var = 'sfcWind',
                 file_date = dates_file,
                 time = values(dates),
                 latitude = indices(1:10),
                 longitude = indices(1:10),
                 time_var = 'time',
                 time_tolerance = as.difftime(1, units = 'hours'),
                 time_across = 'file_date',
                 return_vars = list(latitude = NULL,
                                    longitude = NULL,
                                    time = 'file_date'),
                 merge_across_dims = TRUE,
                 split_multiselected_dims = TRUE)


wrap_cal <- function(obs) {
print(dim(obs))
  return(obs)
}

step <- Step(wrap_cal,
             target_dims = c('time'),
             output_dims = c('time')
        )

wf <- AddStep(obs, step)

# split_dim
# $time
# sdate  time 
#    27    61 
# The operational dim must have sdate and time, or it crashes
res_fn <- Compute(wf, chunks = list(sdate = 1))
