library(startR)

file <- "/esarchive/exp/ncep/cfs-v2/weekly_mean/s2s/$var$_f24h/$var$_$file_date$.nc"
var <- 'tas'
sdates <- c('20130611')  #exists
sdates <- c('20130618')  #does not exist
sdates <- c('20130625')  #exists
sdates <- c("20130611", "20130625")
sdates <- c("20130611", "20130618")

data <- Start(dat = file,
              var = var,
              file_date = sdates,
              time = indices(1:4),
              latitude = values(list(20, 50)),
              latitude_reorder = Sort(decreasing = TRUE),
              longitude = values(list(-20, 10)),
              longitude_reorder = CircularSort(-180, 180),
              synonims = list(latitude=c('lat','latitude'),
                              longitude=c('lon','longitude')),
              ensemble = indices(1),
              return_vars = list(latitude = 'dat',
                                 longitude = 'dat',
                                 time = c('file_date')),
              #split_multiselected_dims = TRUE,
              num_procs = 1,
              retrieve = T)

