# Loading simulation data:
repos <- '/esarchive/exp/ecearth/a1ua/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/r10i1p1f1/Omon/tos/gr/v20190713/$var$_Omon_EC-Earth3_dcppA-hindcast_s$sdate$-$memb$_gr_$chunk$.nc'

data <- Start(dat = repos,
              var = 'tos',
              memb = c('r10i1p1f1'),
              sdate = c('1960', '1965'),
              time = indices(1:36),
              chunk = 'all',
              lat = 'all',
              lon = 'all',
              chunk_depends = 'sdate',
              time_across = 'chunk',
              merge_across_dims = TRUE,
              return_vars = list(lat = NULL, lon = NULL, time = c('sdate', 'chunk')),
              retrieve = F) 

#dates <- attr(data, 'Variables')$common$time
#dim(dates)
#sdate chunk  time 
#    2     3    12 
#library(s2dv)
#tmp <- Reorder(dates, c('time', 'chunk', 'sdate'))
#dates <- .POSIXct(tmp, dim = c(time = 36, sdate = 2))
#dates[,1] <- .POSIXct(tmp[,,1])
#dates[,2] <- tmp[,,2]

dates <- as.POSIXct(c(seq.Date(as.Date('1960-11-15', format = '%Y-%m-%d'),
                   as.Date('1963-10-15', format = '%Y-%m-%d'),
                   by = 'month'), seq.Date(as.Date('1965-11-15', format = '%Y-%m-%d'),
                   as.Date('1968-10-15', format = '%Y-%m-%d'),
                   by = 'month')))

dim(dates) <- c(time = 36, sdate = 2)
library(s2dv)
dates <- Reorder(dates, c('sdate', 'time'))

#file_date <- sort(unique(gsub('-', '', sapply(as.character(dates), substr, 1, 7))))

path = '/esarchive/exp/ecearth/a1ts/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/$memb$/Omon/$var$/gr/v20190312/$var$_Omon_EC-Earth3_historical_$memb$_gr_$date$.nc'

chunks <- c('196001-196012', '196101-196112', '196201-196212', '196301-196312',
          '196501-196512','196601-196612', '196701-196712', '196801-196812')


histo <- Start(dat = path,
              var = 'tos',
              memb = c('r25i1p1f1'),
              date = chunks,
              time = dates,
              lat = 'all', #indices(1:2), #'all',
              lon = 'all', #indices(1:2), #'all',
              time_across = 'date',
              merge_across_dims = TRUE,
              merge_across_dims_narm = TRUE,
              split_multiselected_dims = TRUE,
              return_vars = list(lat = NULL, lon = NULL, time = 'date'),
              retrieve = TRUE)



library(ncdf4)

file1960 <- nc_open('/esarchive/exp/ecearth/a1ts/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r25i1p1f1/Omon/tos/gr/v20190312/tos_Omon_EC-Earth3_historical_r25i1p1f1_gr_196001-196012.nc')

tos1960 <- ncvar_get(file1960, 'tos')

file1961 <- nc_open('/esarchive/exp/ecearth/a1ts/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r25i1p1f1/Omon/tos/gr/v20190312/tos_Omon_EC-Earth3_historical_r25i1p1f1_gr_196101-196112.nc')

tos1961 <- ncvar_get(file1961, 'tos')


file1962 <- nc_open('/esarchive/exp/ecearth/a1ts/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r25i1p1f1/Omon/tos/gr/v20190312/tos_Omon_EC-Earth3_historical_r25i1p1f1_gr_196201-196212.nc')

tos1962 <- ncvar_get(file1962, 'tos')


file1963 <- nc_open('/esarchive/exp/ecearth/a1ts/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r25i1p1f1/Omon/tos/gr/v20190312/tos_Omon_EC-Earth3_historical_r25i1p1f1_gr_196301-196312.nc')

tos1963 <- ncvar_get(file1963, 'tos')


file1965 <- nc_open('/esarchive/exp/ecearth/a1ts/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r25i1p1f1/Omon/tos/gr/v20190312/tos_Omon_EC-Earth3_historical_r25i1p1f1_gr_196501-196512.nc')

tos1965 <- ncvar_get(file1965, 'tos')

