library(startR)

var_name='sfcWind'
path.exp <- '/esarchive/exp/ecmwf/s2s-monthly_ensforhc/daily/$var$_f24h/$sdate$/$var$_$syear$.nc'

hcst <- Start(dat = path.exp,
              var =  var_name,
              sdate = '20161222',
              syear = indices(1:2), #'all',
              time = indices(1:11), #'all',            
              latitude=indices(c(1)),#'all',
              longitude=indices(1),#'all',
              ensemble = 'all',
              syear_depends = 'sdate',
          #    synonims = list(time_day = 'time'),
              return_vars = list(latitude = 'dat',
                                 longitude = 'dat',
                                 time = c('sdate','syear')
                                 ),
              retrieve = F)
 
dates <- attr(hcst, 'Variables')$common$time 
library(s2dv)
dates <- Reorder(dates,c('sdate','time','syear'))

file_date <- sort(unique(gsub('-', '', sapply(as.character(dates), substr, 1, 7))))

#> dim(dates)
#sdate syear  time
#    1    20    47
# get YYYYMM format (ERA5 is stored as 1 month files with all the hourly values 720 or 740)

##file_date <- sapply(dates, format, '%Y%m')
##dim(file_date) <- dim(dates)

path.obs <- '/esarchive/recon/ecmwf/era5/1hourly/$var$/$var$_$file_date$.nc'

obs <- Start(dat = path.obs, 
             var = var_name,
             file_date = file_date,   # a vector
             latitude = indices(1),
             longitude =indices(1),
             time = values(dates),    # a 3-dim array (sdate, syear, time)
             time_across = 'file_date',
             merge_across_dims = TRUE,
             merge_across_dims_narm = TRUE,
             synonims = list(latitude = c('lat','latitude'),
                             longitude = c('lon','longitude'),
                             time = 'time'), 
             return_vars = list(latitude = 'dat',
                                longitude = 'dat',
                                time = c('file_date')),
             split_multiselected_dims = TRUE,
             retrieve = T)         
 
attr(obs, 'Variables')$common$time

# use ncdf4 to examine
library(ncdf4)
file199612 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199612.nc')

wind199612 <- ncvar_get(file199612, 'sfcWind')

file199712 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199712.nc')

wind199712 <- ncvar_get(file199712, 'sfcWind')


file199701 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199701.nc')
wind199701 <- ncvar_get(file199701, 'sfcWind')


file199801 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199801.nc')
wind199801 <- ncvar_get(file199801, 'sfcWind')


#================
library(startR)
library(s2dv)

# HINDCAST
ecmwf_path_hc <- paste0('/esarchive/exp/ecmwf/s2s-monthly_ensforhc/daily/$var$_f24h/$sdate$/$var$_$syear$.nc')
#OBS
obs_path <-paste0('/esarchive/recon/ecmwf/era5/daily/$var$-r240x121/$var$_$file_date$.nc')

var_name <- 'sfcWind'
var100_name <- 'windagl100'

#sdates.seq<- c("20161222","20161229","20170105","20170112")
sdates.seq<- c("20161222","20170828")


hcst<-Start(dat = ecmwf_path_hc,
            var = var_name,
            sdate = sdates.seq,
            syear = 'all', #indices(1:3),
            time = 'all', #indices(1:5), 
            latitude = indices(1),
            longitude = indices(1),
            ensemble = 'all',
            syear_depends = 'sdate',
            return_vars = list(latitude = 'dat',
                                 longitude = 'dat',
                                 time = c('sdate','syear')
                                  ),
            retrieve = F)
            
dates <- attr(hcst, 'Variables')$common$time
#dates<-Reorder(dates,c('sdate','time','syear'))
###NEW###
dates<-Reorder(dates,c('time','sdate','syear'))
######
file_date <- sapply(dates, format, '%Y%m')
#files_summary<-sort(unique(file_date))
files_summary <- unique(file_date)

obs <- Start(dat = obs_path, 
             var = var100_name,
             file_date= files_summary,   
             time = values(dates),    # 'sdate' 'time' 'syear'
             time_var = 'time',
             time_across = 'file_date',
             merge_across_dims= TRUE,
             merge_across_dims_narm = TRUE,
             split_multiselected_dims = TRUE,
             latitude = indices(1),
             longitude = indices(1),
             synonims = list(latitude=c('lat','latitude'),
                             longitude=c('lon','longitude')), 
             return_vars = list(latitude = 'dat',
                                longitude = 'dat',#
                                time = c('file_date')),
             retrieve=T)


library(ncdf4)
file199612 <- nc_open('/esarchive/recon/ecmwf/era5/daily/windagl100-r240x121/windagl100_199612.nc')

wind199612 <- ncvar_get(file199612, 'windagl100')

file199701 <- nc_open('/esarchive/recon/ecmwf/era5/daily/windagl100-r240x121/windagl100_199701.nc')

wind199701 <- ncvar_get(file199701, 'windagl100')
