library(startR)

var_name='sfcWind'
path.exp <- '/esarchive/exp/ecmwf/s2s-monthly_ensforhc/daily/$var$_f24h/$sdate$/$var$_$syear$.nc'

hcst <- Start(dat = path.exp,
              var =  var_name,
              sdate = '20161222',
              syear = indices(1:2), #'all',
              time = indices(1:4), #'all',            
              latitude=indices(1),#'all',
              longitude=indices(1),#'all',
              ensemble = 'all',
              syear_depends = 'sdate',
          #    synonims = list(time_day = 'time'),
              return_vars = list(latitude = 'dat',
                                 longitude = 'dat',
                                 time = c('sdate','syear')
                                 ),
              retrieve = F)
 
dates <- attr(hcst, 'Variables')$common$time 
file_date <- sort(unique(gsub('-', '', sapply(as.character(dates), substr, 1, 7))))

#> dim(dates)
#sdate syear  time
#    1    20    47
# get YYYYMM format (ERA5 is stored as 1 month files with all the hourly values 720 or 740)

##file_date <- sapply(dates, format, '%Y%m')
##dim(file_date) <- dim(dates)

path.obs <- '/esarchive/recon/ecmwf/era5/1hourly/$var$/$var$_$file_date$.nc'

obs <- Start(dat = path.obs, 
             var = var_name,
             file_date = file_date,   # a vector
             latitude = indices(1),
             longitude =indices(1),
             time = values(dates),    # a 3-dim array (sdate, syear, time)
             time_across = 'file_date',
             merge_across_dims = TRUE,

             synonims = list(latitude = c('lat','latitude'),
                             longitude = c('lon','longitude'),
                             time = 'time'), 
             return_vars = list(latitude = 'dat',
                                longitude = 'dat',
                                time = c('file_date')),
             split_multiselected_dims = TRUE,
             retrieve = F)         
 
attr(obs, 'Variables')$common$time


func <- function(x) {
  return(x)
}
step <- Step(func,
             target_dims = 'time',
             output_dims = 'time')
wf <- AddStep(obs, step)

res <- Compute(wf, chunks = list(syear = 2))


# use ncdf4 to examine
library(ncdf4)
file199612 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199612.nc')

wind199612 <- ncvar_get(file199612, 'sfcWind')

file199712 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199712.nc')

wind199712 <- ncvar_get(file199712, 'sfcWind')


file199701 <- nc_open('/esarchive/recon/ecmwf/era5/1hourly/sfcWind/sfcWind_199701.nc')
wind199701 <- ncvar_get(file199701, 'sfcWind')

