library(startR)

yrh1 = 1960
yrh2 = 1961
years  <- paste0(c(yrh1 : yrh2), '01-', c(yrh1 : yrh2), '12')

## case 1: Original ##
repos <- '/esarchive/exp/ecearth/$expid$/diags/CMIP/EC-Earth-Consortium/EC-Earth3/historical/$member$/Omon/$var$/gn/$version$/$var$_Omon_EC-Earth3_historical_$member$_gn_$year$.nc'
data <- Start(dat = repos,
              var = 'tosmean',
              expid =  c('a1st','a1sx'),
  #            expid = 'a1st', 
              member = indices(1), # 'all',
              version =  indices(1), #'all',
              member_depends = 'expid',
              member_depends = 'version',
              version_depends = 'expid',
              version_depends = 'member',  
              year = years,
              time = indices(1),
              region = indices(1),
              return_vars = list(time = NULL, region = NULL),
              retrieve = T)

## case 2: version -> * ##
repos <- '/esarchive/exp/ecearth/$expid$/diags/CMIP/EC-Earth-Consortium/EC-Earth3/historical/*/Omon/$var$/gn/v*/$var$_Omon_EC-Earth3_historical_*_gn_$year$.nc'
data <- Start(dat = repos,
              var = 'tosmean',
              expid =  c('a1st','a1sx'),
#              member = indices(1), # 'all',
#              member_depends = 'expid',
              year = years,
              time = indices(1),
              region = indices(1),
              path_glob_permissive = 3, #TRUE,
              return_vars = list(time = NULL, region = NULL),
              retrieve = T)

#####################################

library(startR)

vari='tosmean'
mod = 'Omon'
grid = 'gn'
reg = 'Global_Ocean'
yrh1 = 1960
yrh2 = 2014
years  <- paste0(c(yrh1:yrh2), '01-', c(yrh1:yrh2), '12')
reg_ind = 4
expid=c('a1st','a1sx')
repos <-paste0('/esarchive/exp/ecearth/',expid,'/diags/CMIP/EC-Earth-Consortium/EC-Earth3/historical/r*/',mod,'/$var$/',grid,'/v*/$var$_',mod,'_EC-Earth3_historical_*_',grid,'_$year$.nc',sep='')

data_cmip6_h <- Start(dat = repos,
                        var = vari,
                        region=indices(c(4)),
                        year = years,
                        time = 'all',
                        return_vars = list(time = NULL, region=NULL),
                        retrieve = T)

data_cmip6_h[,1,1,1,1]




#=====================
repos <- '/esarchive/exp/ecearth/$expid$/diags/CMIP/EC-Earth-Consortium/EC-Earth3/historical/$member$/Omon/$var$/gn/$version$/$var$_Omon_EC-Earth3_historical_$member$_gn_$year$.nc'

yrh1 = 1960
yrh2 = 2014
years  <- paste0(c(yrh1 : yrh2), '01-', c(yrh1 : yrh2), '12')
data <- Start(dat = repos,
              var = 'tosmean',
              expid =  c('a1st','a1sx'),
              member = 'all',
              version =  'all',
              member_depends = 'expid',
              version_depends = 'expid',
              year = years,
              time = 'all',
              region = indices(1 : 4),
              return_vars = list(time = NULL, region = NULL),
              retrieve = TRUE)

data[1, 1, 2, 1, 1, , , 1]
