path <- '/esarchive/recon/ecmwf/era5/daily_mean/$var$_f1h/$var$_$months$.nc'
library(lubridate)
dates <- seq(ymd('20060101'), ymd('20181201'), by = 'month')

dates <- format(dates, "%Y%m")
data <- Start(dataset = path,
             var = 'psl',
             months = dates,
             time = 'all',
             latitude = values(list(30, 50)),
    #         latitude_reorder = Sort(decreasing = FALSE),
             longitude = values(list(-10, 10)),
             longitude_reorder = CircularSort(-180, 180),
             transform = CDORemapper,
             transform_extra_cells = 2,
             transform_params = list(grid = 'r360x181',
                                     method = 'conservative',
                                     crop = c(-10, 10,
                                              30, 50)),
             transform_vars = c('latitude', 'longitude'),
             synonims = list(latitude = c('lat', 'latitude'),
                             longitude = c('lon', 'longitude')),
             return_vars = list(latitude = 'dataset',
                                longitude = 'dataset',
                                time = NULL),
             retrieve = T)

