library(maps)
library(ncdf4)
library(s2dverification)
library(startR)
library(stats)


exp= 'a2s5'
vari = 'tas'
mod = 'Amon'
grid = 'gr' #r360x180 #gn #gr
yrh1 = 2249
yrh2 = 2298
years  <- paste0(c(yrh1:yrh2), '01-', c(yrh1:yrh2), '12')
repos <- paste0('/esarchive/exp/ecearth/',exp,'/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3-HR/piControl/$memb$/',
                mod,'/$var$/', grid, '/v20200425/$var$_',mod,'_EC-Earth3-HR_piControl_$memb$_',grid,'_$year$.nc',sep='')
# tas_Amon_EC-Earth3-HR_piControl_r1i1p1f1_gr_229801-229812.nc

lon.min <- 0
lon.max <- 359.83  # it cannot be 360 due to the upper limit of CircularSort() is 360
lat.min <- -90
lat.max <- 90
data <- Start(dat = repos, 
                       var = vari, 
                       memb = 'r1i1p1f1',
                       year = '224901-224912',
                       time = indices(1),
                       lat = values(list(lat.min, lat.max)), #'all',
                       lat_reorder = Sort(),
                       lon = values(list(lon.min, lon.max)), #'all',
                       lon_reorder = CircularSort(0, 360),
                       synonims = list(lat = c('lat', 'latitude'), 
                                       lon = c('lon', 'longitude')),
                       transform = CDORemapper,
                       transform_extra_cells = 2,
                       transform_params = list(grid = 'r360x181',
                                               method = 'conservative',
                                              crop = c(lon.min, lon.max,
                                                       lat.min, lat.max)),
                       transform_vars = c('lat', 'lon'),
                       # why there is no time in the list of the return_vars?
                       # return_vars = list(lat=NULL, lon=NULL),
                       return_vars = list(time = 'year', lat='dat', lon='dat'),
                       #return_vars = list(time = NULL,
                       #         latitude = 'dat',
                       #         longitude = 'dat'),
                       retrieve = T)

print(dim(data_init_interp))
print(attr(data_init_interp, 'Variables')$dat1$lat)
print(attr(data_init_interp, 'Variables')$dat1$lon)


