path_list <- list(
              MPI = list(name = 'MPI-ESM',
                         path = paste0('/esarchive/exp/CMIP6/dcppA-hindcast/mpi-esm1-2-hr/',
                                       'cmip6-dcppA-hindcast_i1p1/DCPP/MPI-M/MPI-ESM1-2-HR/',
                                       'dcppA-hindcast/$member$/day/$var$/gn/v20200101/',
                                       '$var$_day_MPI-ESM1-2-HR_dcppA-hindcast_s$sdate$-$member$_gn_$chunk$.nc')),
             Had = list(name = 'HadGEM3', 
                        path = paste0('/esarchive/exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/',
                                      'cmip6-dcppA-hindcast_i1p1/DCPP/MOHC/HadGEM3-GC31-MM/',
                                      'dcppA-hindcast/$member$/day/$var$/gn/v20200101/',
                                      '$var$_day_HadGEM3-GC31-MM_dcppA-hindcast_s$sdate$-$member$_gn_$chunk$.nc')))

data <- Start(dataset = path_list,
              var = 'tasmin',
              member = list(c('r1i1p1f1', 'r2i1p1f2')),  #indices(2) #work!
             sdate = paste0(2018),
              chunk = list(c('20181101-20281231', '20181101-20281230')), #indices(1) #work!
              time = 'all',
              lat = values(list(0, 14)),
              lon = values(list(0, 28)),
             #chunk_depends = 'member',
             #time_across = 'chunk',
             # merge_across_dims = TRUE, 
              synonims = list(time = c('fmonth','time'), 
                              lon = c('lon', 'longitude'), 
                              lat = c('lat', 'latitude')),
              transform = CDORemapper,
              transform_extra_cells = 2,
              transform_params = list(grid = 'r200x100', 
                   method = 'conservative', crop = c(0,28,0,14)),
              transform_vars = c('lat', 'lon'),
              return_vars = list(lat = 'dataset', lon = 'dataset'),
              lat_reorder = Sort(),
              num_procs = 1, 
              retrieve = F)

