#NOTE: The case needs regridding... The lat/lon is not the same between these two datasets.

# Define selectors
  # HadGEM3 daily data (360_day)
  path_hadgem3 <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/',
                         'cmip6-dcppA-hindcast_i1p1/DCPP/MOHC/HadGEM3-GC31-MM/',
                         'dcppA-hindcast/r1i1p1f2/day/$var$/gn/v20200101/',
                         '$var$_day_HadGEM3-GC31-MM_dcppA-hindcast_s$sdate$-r1i1p1f2_gn_$fyear$.nc')
  ## tasmax_day_HadGEM3-GC31-MM_dcppA-hindcast_s2000-r1i1p1f2_gn_20001101-20101230.nc

  # MPI-ESM1.2-HR (standard)
  path_mpi_esm <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/mpi-esm1-2-hr/',
                         'cmip6-dcppA-hindcast_i1p1/DCPP/MPI-M/MPI-ESM1-2-HR/',
                         'dcppA-hindcast/r1i1p1f1/day/$var$/gn/v20200101/',
                         '$var$_day_MPI-ESM1-2-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$fyear$.nc')
  ## tasmax_day_MPI-ESM1-2-HR_dcppA-hindcast_s2000-r1i1p1f1_gn_20001101-20101231.nc

  # Selectors
  sdate <- '2000'
  fyear_hadgem3 <- paste0(sdate, '1101-', as.numeric(sdate) + 10, '1230')
  fyear_mpi_esm <- paste0(sdate, '1101-', as.numeric(sdate) + 10, '1231')
  time_hadgem3 <- indices(c(60, NA, 61)) #12/30, NA, 1/1
  time_mpi_esm <- indices(60:62) #12/30, 12/31, 1/1


res <- multiStart(
         dat = list(list(name = 'hadgem3', path = path_hadgem3),
                    list(name = 'mpi_esm', path = path_mpi_esm)),
         var = 'tasmax', sdate = '2000',
         fyear = list(list(name = 'hadgem3', fyear = fyear_hadgem3),
                      list(name = 'mpi_esm', fyear = fyear_mpi_esm)),
         time = list(list(name = 'hadgem3', time = time_hadgem3),
                     list(name = 'mpi_esm', time = time_mpi_esm)),
         lat = indices(1), lon = indices(1),
         #fyear_depends = 'sdate',
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)


#----------------merge_across_dim-----------------
path <-'/esarchive/recon/ecmwf/erainterim/monthly_mean/$var$_f6h/$var$_$sdate$.nc'
sdate <- c('199801', '199802', '199803')
time <- indices(c(1, 2, NA, 3))
res <- multiStart(
         dat = list(list(name = 'erainterim', path = path)),
         var = c('ps', 'tas'), 
         sdate = sdate,
         time = list(list(name = 'erainterim', time = time)),
         time_across = 'sdate',
         merge_across_dims = TRUE,
         lat = indices(1), lon = indices(1),
         synonims = list(lat = c('lat', 'latitude'),
                         lon = c('lon', 'longitude')),
         return_vars = list(lat = NULL, lon = NULL, time = 'sdate'),
         retrieve = TRUE)


#----------------------------------------
# Start() separately
res1 <- Start(
         dat = list(list(name = 'hadgem3', path = path_hadgem3)),
         var = 'tasmax', sdate = '2000',
         fyear = fyear_hadgem3,
         time = indices(c(60, 61)),
         lat = indices(1:2), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)

res2 <- Start(
         dat = list(list(name = 'mpi_esm', path = path_mpi_esm)),
         var = 'tasmax', sdate = '2000',
         fyear = fyear_mpi_esm,
         time = time_mpi_esm,
         lat = indices(1:2), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)


str(res)
attr(res, 'Variables')$hadgem3$time
[1] "2000-12-29 12:00:00 UTC" "2000-12-30 12:00:00 UTC"
[3] "2001-01-01 12:00:00 UTC" "2001-01-02 12:00:00 UTC"
res_list$test_mpi_esm
[1] "2000-12-29 12:00:00 UTC" "2000-12-30 12:00:00 UTC"
[3] "2000-12-31 12:00:00 UTC" "2001-01-01 12:00:00 UTC"



#=======================================================
# retrieve = FALSE; Compute()
#=======================================================
.warning <- startR:::.warning

res <- multiStart(
         dat = list(list(name = 'hadgem3', path = path_hadgem3),
                    list(name = 'mpi_esm', path = path_mpi_esm)),
         var = 'tasmax', sdate = '2000',
         fyear = list(list(name = 'hadgem3', fyear = fyear_hadgem3),
                      list(name = 'mpi_esm', fyear = fyear_mpi_esm)),
         time = list(list(name = 'hadgem3', time = time_hadgem3),
                     list(name = 'mpi_esm', time = time_mpi_esm)),
         lat = indices(3:5), lon = indices(1),
         #fyear_depends = 'sdate',
         return_vars = list(lat = 'dat', lon = 'dat', time = 'dat'),
         retrieve = FALSE)

str(res)
#str(attr(res[[1]], 'na_pos_record'))
#str(attr(res[[2]], 'na_pos_record'))

func2 <- function(x, y) {
  return(x + y)
}

#step2 <- Step(func2, target_dims = list(res1 = c('var', 'time'), res2 = c('var', 'time')),
#                     output_dims = c('var', 'time'))
step2 <- Step(func2, target_dims = list(res1 = c('var', 'lon'), res2 = c('var', 'lon')),
                     output_dims = c('var', 'lon'))

#----------------------------
func2 <- function(...) {
dats <- list(...)
dats <- do.call(abind::abind, c(dats, along = 0))
res <- s2dv::MeanDims(dats, 1)
return(res)
}

target_dim <- list(c('var', 'lon'))
target_dims <- rep(target_dim, length(res))
names(target_dims) <- paste0('dat', 1:length(res))
step2 <- Step(func2, target_dims = target_dims, output_dims = target_dim)

#----------------------------

wf <- AddStep(res, step2)

## trace Compute and change ByChunks to multi_ByChunks...
#source('/home/Earth/aho/aho-testtest/startR/issue/issue72/.MergeArrayOfArrays.R')

output <- Compute(wf, chunks = list(lat = 2, time = 2))

dim(output$output1)
  var   lon  time   dat sdate fyear   lat 
    1     1     3     1     1     1     3 
output$output1[1,1,,1,1,1,]
         [,1]     [,2]     [,3]
[1,] 503.0177 502.6464 503.0280
[2,]       NA       NA       NA
[3,] 507.7226 507.1748 507.9795


#-------------------user-defined---------------------
  queue_host <- 'nord1'
  temp_dir <- '/gpfs/scratch/bsc32/bsc32734/startR_hpc/'
  ecflow_suite_dir <- '/home/Earth/aho/startR_local/'
#----------------------------------------------------

  output <- Compute(wf,
                 chunks = list(lat = 2, time = 2),
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = queue_host,
                   queue_type = 'lsf',
                   temp_dir = temp_dir,
lib_dir = '/.statelite/tmpfs/gpfs/home/bsc32/bsc32734/R/x86_64-pc-linux-gnu-library/3.6',
                   cores_per_job = 2,
                   job_wallclock = '05:00',
                   max_jobs = 4,
                   extra_queue_params = list('#BSUB -q bsc_es'),
                   bidirectional = FALSE,
                   polling_period = 10
                 ),
                 ecflow_suite_dir = ecflow_suite_dir,
                 wait = TRUE
                 )  #$output1

#----------------------------------------------------

res1 <- Start(
         dat = list(list(name = 'hadgem3', path = path_hadgem3)),
         var = 'tasmax', sdate = '2000',
         fyear = fyear_hadgem3,
         time = indices(c(60, 61)),
         lat = indices(1:2), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = FALSE)

res2 <- Start(
         dat = list(list(name = 'mpi_esm', path = path_mpi_esm)),
         var = 'tasmax', sdate = '2000',
         fyear = fyear_mpi_esm,
         time = indices(c(60, 61, 62)),
         lat = indices(1:2), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = FALSE)

func2 <- function(x, y) {
  return(x + y)
}

step2 <- Step(func2, target_dims = list(res1 = c('var', 'fyear'), res2 = c('var', 'fyear')), 
                     output_dims = c('var', 'fyear'))

wf2 <- AddStep(list(res1, res2), step2)

output2 <- Compute(wf2, chunks = list(lat = 2))











