library(startR)

ltmin <- 20
ltmax <- 30
lnmin <- 60
lnmax <- 70

repos <- list(list(name = 'system5c3s',
                   path = "/esarchive/exp/ecmwf/system5c3s/monthly_mean/g500_f12h/$var$_$sdate$.nc"),
              list(name = 'system3_m1-c3s',
                   path = "/esarchive/exp/cmcc/system3_m1-c3s/monthly_mean/g500_f12h/$var$_$sdate$.nc"))

# The order of list doesn't impact
#repos <- list(list(name = 'system3_m1-c3s',
#                   path = "/esarchive/exp/cmcc/system3_m1-c3s/monthly_mean/g500_f12h/$var$_$sdate$.nc"),
#              list(name = 'system5c3s',
#                   path = "/esarchive/exp/ecmwf/system5c3s/monthly_mean/g500_f12h/$var$_$sdate$.nc"))

tmp3 <- Start(
        dataset = repos,
        var = "g500", 
        sdate = c("19931101", "20200901"),
        time = 'all',
        ensemble = 'all',
        latitude = values(list(ltmin, ltmax)),      
        latitude_reorder = Sort(decreasing = T),              
        longitude = values(list(lnmin, lnmax)),              
        longitude_reorder = CircularSort(0, 360),         
        synonims = list(longitude = c('lon', 'longitude'),                              
                        latitude = c('lat', 'latitude')),              
        transform = CDORemapper,
        transform_extra_cells = 2,              
        transform_params = list(grid = 'r360x181',                                     
                                method = 'conservative',                                      
                                crop = c(lnmin, lnmax, ltmin, ltmax)),              
        transform_vars = c('latitude', 'longitude'),              
        largest_dims_length = TRUE,
        return_vars = list(time = NULL,
                           latitude = 'dataset',                            
                           longitude = 'dataset'),          
        retrieve = T)
