library(startR)

#-------- Define selectors -------------
  # HadGEM3 daily data
  path_hadgem3 <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/',
                         'cmip6-dcppA-hindcast_i1p1/DCPP/MOHC/HadGEM3-GC31-MM/',
                         'dcppA-hindcast/r1i1p1f2/day/$var$/gn/v20200101/',
                         '$var$_day_HadGEM3-GC31-MM_dcppA-hindcast_s$sdate$-r1i1p1f2_gn_$fyear$.nc')
  ## tasmax_day_HadGEM3-GC31-MM_dcppA-hindcast_s2000-r1i1p1f2_gn_20001101-20101230.nc

  #=== MPI-ESM1.2-HR ===
  path_mpi_esm <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/mpi-esm1-2-hr/',
                         'cmip6-dcppA-hindcast_i1p1/DCPP/MPI-M/MPI-ESM1-2-HR/',
                         'dcppA-hindcast/r1i1p1f1/day/$var$/gn/v20200101/',
                         '$var$_day_MPI-ESM1-2-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$fyear$.nc')
  ## tasmax_day_MPI-ESM1-2-HR_dcppA-hindcast_s2000-r1i1p1f1_gn_20001101-20101231.nc

  # Selectors
  var <- 'tasmax'
  sdate <- '2000'
  fyear_hadgem3 <- paste0(sdate, '1101-', as.numeric(sdate) + 10, '1230')
  fyear_mpi_esm <- paste0(sdate, '1101-', as.numeric(sdate) + 10, '1231')
  time_hadgem3 <- indices(59:62) #'all'
  time_mpi_esm <- indices(59:62)

test_2 <- list(test_hadgem3 = list(name = 'hadgem3', path = path_hadgem3, 
                                   fyear = fyear_hadgem3, time = time_hadgem3),
               test_mpi_esm = list(name = 'mpi_esm', path = path_mpi_esm,
                                   fyear = fyear_mpi_esm, time = time_mpi_esm))

res_list <- lapply(test_2, function(x) {
  list2env(x, env = .GlobalEnv)
  suppressWarnings(
    data <- Start(dat = path,
                  var = 'tasmax', sdate = '2000',
                  fyear = fyear,
                  time = time,
                  lat = indices(1), lon = indices(1),
                  #fyear_depends = 'sdate',
                  return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'), #'dat'),
                  num_procs = 1,
#                  debug = TRUE,
                  retrieve = TRUE)
  )
#  dates <- attr(data, 'Variables')$dat$time
  dates <- attr(data, 'Variables')$common$time
print(paste0('The first two dates of ', name))
print(dates[1:2])
print('done!!')
  return(dates)
})

str(res_list)
res_list$test_hadgem3
[1] "2000-12-29 12:00:00 UTC" "2000-12-30 12:00:00 UTC"
[3] "2001-01-01 12:00:00 UTC" "2001-01-02 12:00:00 UTC"
res_list$test_mpi_esm
[1] "2000-12-29 12:00:00 UTC" "2000-12-30 12:00:00 UTC"
[3] "2000-12-31 12:00:00 UTC" "2001-01-01 12:00:00 UTC"
