library(startR)
repos_obs <- '/esarchive/obs/ukmo/hadisst_v1.1/monthly_mean/$var$/$var$_$date$.nc'

#===========Selector is values()=============
# (1)
# WRONG NAMES!!!!
res <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = values(list(5, 10)),  
             lat_reorder = Sort(),
             lon = values(list(15, 20)),
             lon_reorder = CircularSort(0, 360),
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(latitude = NULL,  # the name should be lat
                                longitude = NULL,
                                time = 'date'),
             retrieve = TRUE)

names(attr(res, 'Variables')$common)
# [1] "latitude"  "longitude" "time"      "lat"       "lon"       "tos"      
str(attr(res, 'Variables')$common$lat)   #CORRECT
str(attr(res, 'Variables')$common$latitude)  #CORRECT



# (2)
res2 <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = values(list(-10, 10)),
             lat_reorder = Sort(),
             lon = values(list(10, 20)),
             lon_reorder = CircularSort(0, 360),
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(lat = NULL,  # the name should be lat
                                lon = NULL,
                                time = 'date'),
             retrieve = TRUE)
names(attr(res2, 'Variables')$common)
# [1] "lat"  "lon"  "time" "tos" 
str(attr(res2, 'Variables')$common$lat)   #CORRECT

# (3)
res3 <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = values(list(-10, 10)),
             lat_reorder = Sort(),
             lon = values(list(10, 20)),
             lon_reorder = CircularSort(0, 360),
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(lat = 'dat',  # the name should be lat
                                lon = 'dat',
                                time = 'date'),
             retrieve = TRUE)
names(attr(res3, 'Variables')$dat1)
# [1] "lat"  "lon"   #CORRECT
str(attr(res3, 'Variables')$dat1$lat)   #CORRECT

# (4)
# WRONG attr!!!!
res4 <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = values(list(-10, 10)), 
             lat_reorder = Sort(),
             lon = values(list(10, 20)),
             lon_reorder = CircularSort(0, 360),
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(latitude = 'dat',  # the name should be lat
                                longitude = 'dat',
                                time = 'date'),
             retrieve = TRUE)
names(attr(res4, 'Variables')$dat1)
# [1] "latitude"  "longitude"
names(attr(res4, 'Variables')$common)
# [1] "time" "lat"  "lon"  "tos" 
str(attr(res4, 'Variables')$dat1$latitude)   #CORRECT
str(attr(res4, 'Variables')$common$lat)   #CORRECT


#===========Selector is indices()=============
# (1)
obs <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = indices(100:110),
             lon =  indices(100:110), 
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(lat = NULL,  # the name should be lat
                                lon = NULL,
                                time = 'date'),
             retrieve = TRUE)
names(attr(obs, 'Variables')$common)
str(attr(obs, 'Variables')$common$lat)   #CORRECT

# (2)
# Wrong attr!!!!!!!!!!!!!!!!!!!
obs2 <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = indices(100:110),
             lon =  indices(100:110), 
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(latitude = NULL,  # the name should be lat
                                longitude = NULL,
                                time = 'date'),
             retrieve = TRUE)
names(attr(obs2, 'Variables')$common)
#[1] "latitude"  "longitude" "time"      "tos"      
str(attr(obs2, 'Variables')$common$latitude)

# (3)
obs3 <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = indices(100:110), 
             lon =  indices(100:110), 
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(latitude = 'dat',  # the name should be lat
                                longitude = 'dat',
                                time = 'date'),
             retrieve = TRUE)
str(attr(obs3, 'Variables')$dat1$latitude)   #CORRECT
names(attr(obs3, 'Variables')$common)
# [1] "time" "tos" 
names(attr(obs3, 'Variables')$dat1)
# [1] "latitude"  "longitude"

# (4)
obs4 <- Start(dat = repos_obs,
             var = 'tos',
             date = '200505',
             time = indices(1),
             lat = indices(100:110),  
             lon =  indices(100:110), 
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(lat = 'dat',  # the name should be lat
                                lon = 'dat',
                                time = 'date'),
             retrieve = TRUE)
str(attr(obs4, 'Variables')$dat1$lat)  
names(attr(obs4, 'Variables')$dat1)
# [1] "lat" "lon"


