library(startR)

repos <- '/esarchive/exp/ecmwf/system5_m1/monthly_mean/$var$_f6h/$var$_$sdate$.nc'

# Get time values
data <- Start(dat = repos,
              var = 'tas',
              sdate = c('20170101', '20180101'),
              ensemble = indices(1),
              time = indices(1:4),
              latitude = indices(1), longitude = indices(1),
              return_vars = list(time = 'sdate'),
              retrieve = F)
time_val <- attr(data, 'Variables')$common$time
dim(time_val)
#sdate  time 
#    2     4 
time_val
#[1] "2017-02-01 UTC" "2018-02-01 UTC" "2017-03-01 UTC" "2018-03-01 UTC"
#[5] "2017-04-01 UTC" "2018-04-01 UTC" "2017-05-01 UTC" "2018-05-01 UTC"

#----------------------------------------------------------------------

# time is values(), return_vars = NULL. WRONG!!!
data6 <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = time_val,
  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = NULL),
  retrieve = TRUE)
attr(data6, 'Variables')$common$time

# time is values(), return_vars = 'sdate'
data4 <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = time_val,
  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = 'sdate'),
  retrieve = TRUE)
attr(data4, 'Variables')$common$time


# time is indices(), return_vars = NULL.
data12 <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = indices(1:4),
#  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = NULL),
  retrieve = TRUE)
attr(data12, 'Variables')$common$time


# time is indices(), return_vars = 'sdate'.
data11 <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = indices(1:4),
#  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = 'sdate'),
  retrieve = TRUE)
attr(data11, 'Variables')$common$time


