
path <- '/esarchive/exp/ecearth/a35b/diags/DCPP/EC-Earth-Consortium/EC-Earth3-HR/dcppA-hindcast/$memb$/Omon/$var$/gn/v*/$var$_Omon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-$memb$_gn_$chunk$-$chunk$.nc'
vari <- 'tosmean'
membs <- c('r1i1p1f1','r2i1p1f1','r3i1p1f1')
startdates <- c('1993','1998','2003','2008','2013')
forecast_month <- c(11,12,1,2)
reg <- 'Nino3'

exp <- Start(dat = path,
              var = vari,
              memb = membs,
              region = indices(9),
#              region = array(reg, dim = c(sdate = 5)), #, chunk = 4)), 
              region_var = 'region',
              sdate = startdates,
              time = 'all', #c(1:length(forecast_month)),
              chunk = 'all',
              chunk_depends = 'sdate',
              time_across = 'chunk', 
              merge_across_dims = TRUE,
              return_vars = list(time=c('sdate', 'chunk'), region = NULL), #dat'), 
#              return_vars = list(time=c('sdate')),
              retrieve = F)



#----------------------------------------------------
# Different region bwtween files
path <- paste0('/esarchive/exp/ecearth/a35b/diags/DCPP/EC-Earth-Consortium/',
               'EC-Earth3-HR/dcppA-hindcast/r1i1p1f1/Omon/$var$_mixed/gn/v20201107/',
               '$var$_Omon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$chunk$.nc')
region <- array(c(12, 13), dim = c(sdate = 2, region = 1))
exp <- Start(dat = path,
             var = 'tosmean',
             sdate = c('2013', '1993'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = region, #indices(c(9, 13)),
#             region = array(reg, dim = c(sdate = 5)), #, chunk = 4)), 
#             region_var = 'region',
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
             largest_dims_length = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = 'sdate'),
#              return_vars = list(time=c('sdate')),
              retrieve = F)


#----------------------------------------------------
# Different region index bwtween files
path <- paste0('/esarchive/exp/ecearth/a35b/diags/DCPP/EC-Earth-Consortium/',
               'EC-Earth3-HR/dcppA-hindcast/r1i1p1f1/Omon/$var$_mixed/gn/v20201107/',
               '$var$_Omon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$chunk$.nc')
#region <- array(c(12, 13), dim = c(sdate = 2, region = 1))
region <- array('Nino3', dim = c(sdate = 2, region = 1))
region <- indices(9)

exp <- Start(dat = path,
             var = 'tosmean',
             sdate = c('1993', '2013'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = region, #indices(c(9, 13)),
#             region_var = 'region',
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
#             largest_dims_length = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = 'sdate'),
#              return_vars = list(time=c('sdate')),
              retrieve = T)


 exp[1,1,,1,]
          [,1]     [,2]
[1,] 24.987885 24.46488
[2,]  4.167362  3.17115


exp1 <- Start(dat = path,
             var = 'tosmean',
             sdate = c('1993'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = indices(9),
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = NULL),
              retrieve = T)



exp2 <- Start(dat = path,
             var = 'tosmean',
             sdate = c('2013'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = indices(11),
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = NULL),
              retrieve = T)



#------------use multiStart----------------
# It works, but the dimension is not what we want, and if two sdates have different length,
# NA need to be inserted --> more after work.

path1 <- paste0('/esarchive/exp/ecearth/a35b/diags/DCPP/EC-Earth-Consortium/',
               'EC-Earth3-HR/dcppA-hindcast/r1i1p1f1/Omon/$var$_mixed/gn/v20201107/',
               '$var$_Omon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$chunk$.nc')
path2 <- paste0('/esarchive/exp/ecearth/a35b/diags/DCPP/EC-Earth-Consortium/',
               'EC-Earth3-HR/dcppA-hindcast/r1i1p1f1/Omon/$var$_mixed/gn/v20201107/',
               '$var$_Omon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$chunk$.nc')

exp <- multiStart(dat = list(list(name = 'dat1', path = path1),
                             list(name = 'dat2', path = path1)),
             var = 'tosmean',
             sdate = list(list(name = 'dat1', sdate = '1993'),
                          list(name = 'dat2', sdate = '2013')),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = list(list(name = 'dat1', region = indices(9)),
                           list(name = 'dat2', region = indices(11))),
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = 'dat'),
              retrieve = T)

exp[,1,1,1,]
         [,1]     [,2]
[1,] 24.98788 24.46488
[2,] 24.47482 24.75953
#----------------------------------------------------
