
# Different region index bwtween files
path <- paste0('/esarchive/exp/ecearth/a35b/diags/DCPP/EC-Earth-Consortium/',
               'EC-Earth3-HR/dcppA-hindcast/r1i1p1f1/Omon/$var$_mixed/gn/v20201107/',
               '$var$_Omon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$chunk$.nc')
#region <- array(c(12, 13), dim = c(sdate = 2, region = 1))
region <- array('Nino3', dim = c(sdate = 2, region = 1))
#region <- array(c(indices(9), indices(11)), dim = c(sdate = 2, region = 1))
#region <- array(c('Nino3', 'Nino3', 'Nino3.4', 'Nino3.4'), dim = c(sdate = 2, region = 2))

exp <- Start(dat = path,
             var = 'tosmean',
             sdate = c('1993', '2013'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = region, #indices(c(9, 13)),
#region_across = 'sdate',
#             region_var = 'region',
             time = 'all',
             time_across = 'chunk',
             merge_across_dims = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = 'sdate'),
              retrieve = T)

exp[1,1,,1,]
          [,1]     [,2]
[1,] 24.987885 24.46488
[2,]  4.167362  3.17115  # indices(9) of 2nd sdate

#----------------------------------------------------------
region <- array('Nino3', dim = c(sdate = 1, region = 1))
exp1 <- Start(dat = path,
             var = 'tosmean',
             sdate = c('1993'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = region,
#             region_var = 'region',
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
#             largest_dims_length = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = 'sdate'),
#              return_vars = list(time=c('sdate')),
              retrieve = T)
exp1[1,1,1,1,]
[1] 24.98788 24.46488


region <- array('Nino3', dim = c(sdate = 1, region = 1))
exp2 <- Start(dat = path,
             var = 'tosmean',
             sdate = c('2013'),
             chunk = indices(1:2),
             chunk_depends = 'sdate',
             region = region,
#             region_var = 'region',
             time = 'all', #c(1:length(forecast_month)),
             time_across = 'chunk',
             merge_across_dims = TRUE,
#             largest_dims_length = TRUE,
             return_vars = list(time = c('sdate', 'chunk'),
                                region = 'sdate'),
#              return_vars = list(time=c('sdate')),
              retrieve = T)
exp2[1,1,1,1,]
[1] 24.47482 24.75953


#--------------------time-----------------------
sdates <- '2000'
## Paths
# HadGEM3 (initialised in November)
path_hadgem3 <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/cmip6-dcppA-hindcast_i1p1/DCPP/',
                       'MOHC/HadGEM3-GC31-MM/dcppA-hindcast/r1i1p1f2/Amon/$var$/gr/v20200316/',
                       '$var$_*_s$sdate$_r1i1p1f2_gr_$fyear$.nc')
# NorCPM1 (initialised in October)
path_norcpm1 <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/norcpm1/cmip6-dcppA-hindcast_i1p1/DCPP/',
                       'NCC/NorCPM1/dcppA-hindcast/r1i1p1f1/Amon/$var$/gn/v20200320/',
                       '$var$_Amon_NorCPM1_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$fyear$.nc')


times <- as.POSIXct("2000-11-16", tz = 'UTC')
# below is wrong!!
#times <- array(as.POSIXct("2000-11-16", tz = 'UTC'), dim = c(dat = 2, time = 1))
#times <- as.POSIXct(times, origin = '1970-01-01', tz = 'UTC')

data_v <- Start(dat = list(list(name = 'hadgem3', path = path_hadgem3),
                           list(name = 'norcpm1', path = path_norcpm1)),
                   var = 'tas',
                   sdate = sdates,
                   fyear = indices(1), ## there is one file per sdate
                   fyear_depends = 'sdate',
                   time = times, 
#time_across = 'dat',
                   lat = indices(1:3),
                   lon = indices(1:2),
                   synonims = list(lon = c('lon', 'longitude'), lat = c('lat', 'latitude')),
                   return_vars = list(lat = 'dat', lon = 'dat',
                                      time = 'dat'),
                   retrieve = TRUE)


#---------------------------------------------------
# merge_across_dim

repos_obs <- '/esarchive/recon/ecmwf/erainterim/monthly_mean/$var$_f6h/$var$_$date$.nc'

obs <- Start(dat = list(name = 'dat1', path = repos_obs),
             var = 'tas',
             date = c('200501', '200601', '200701'),
             time = indices(1:3),
             lat = indices(1:2),
             lon = indices(1:3),
             time_across = 'date',
             merge_across_dims = TRUE,
             synonims = list(lat = c('lat', 'latitude'),
                             lon = c('lon', 'longitude')),
             return_vars = list(lon = NULL,
                                lat = NULL,
                                time = 'date'),
             retrieve = TRUE)

