repos <- '/esarchive/exp/ecmwf/system5_m1/monthly_mean/$var$_f6h/$var$_$sdate$.nc'

# Get time values
data <- Start(dat = repos,
              var = 'tas',
              sdate = c('20170101', '20180101'),
              ensemble = indices(1),
              time = indices(1:4),
              latitude = indices(1), longitude = indices(1),
              return_vars = list(time = 'sdate'),
              retrieve = F)
time_val <- attr(data, 'Variables')$common$time
dim(time_val)
#sdate  time 
#    2     4 
time_val
#[1] "2017-02-01 UTC" "2018-02-01 UTC" "2017-03-01 UTC" "2018-03-01 UTC"
#[5] "2017-04-01 UTC" "2018-04-01 UTC" "2017-05-01 UTC" "2018-05-01 UTC"

#--------------------------------------

test4a <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = time_val,
  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = 'sdate'),
  retrieve = TRUE)


#NOTE: Without the fix in issue91, this call could return wrong data if sdates have different
#      corresponding indices to the values. 
test4 <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = time_val,
#  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = 'sdate'),
  retrieve = TRUE)

# Make up a time_val with a shift in 2nd sdate
tmp <- paste0('2017-0', 2:5, '-01')
tmp2 <- paste0('2018-0', 3:6, '-01')
shift_time_val <- as.POSIXct(c(tmp, tmp2), tz = 'UTC')
dim(shift_time_val) <- c(time = 4, sdate = 2)

# data [sdate = 2] is wrong. It is the same as test4.
test4c <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = shift_time_val,
#  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = 'sdate'),
  retrieve = TRUE)




test14a <- Start(
  dat = repos,
  var = 'tas',
  sdate = c('20170101', '20180101'),
  time = time_val_vector,
  time_across = 'sdate',
  ensemble = c(1, 3),
  latitude = indices(1:3),
  longitude = indices(1:2),
  return_vars = list(time = NULL),
  retrieve = TRUE)

