library(startR)

vari <- 'tas'  
compo <- 'Amon'
expid <- 'a3fy'
lat_min <- -100
lat_max <- 100
lon_min_exp <- 0.5
lon_max_exp <- 359.9
grid_mod <- 'gr'
years_exp  <- paste0(c(2356:2356), '01-', c(2356:2356), '12')
path <- paste0('/esarchive/exp/ecearth/',expid,'/cmorfiles/CMIP/EC-Earth-Consortium/EC-Earth3-HR/piControl/r1i1p1f1/',
                 compo, '/$var$/', grid_mod,'/v*/$var$_', compo,'_EC-Earth3-HR_piControl_r1i1p1f1_', grid_mod,'_$year$.nc')

data_exp_retrieve <- startR::Start(dat = path,
                                   var = vari,
                                   #memb = ,
                                   year = years_exp, # paste(seq(yr1_exp,yr2_exp)),
                                   time = 'all', 
                                   lat = values(list(lat_min, lat_max)),
                                   lat_reorder = Sort(decreasing = T),
                                   lon = values(list(lon_min_exp, lon_max_exp)),
                                   lon_reorder = CircularSort(-180,180),
#                                   lon_reorder = CircularSort(0, 360),
                                   synonims = list(lon = c('lon', 'longitude'),
                                                   lat = c('lat', 'latitude')),
                                   return_vars = list(time= c('year'), 
                                                      lat='dat', 
                                                      lon='dat'),
                                   retrieve = T)



folder <- 'cmorfiles'
vari <- 'tas'  
compo <- 'Amon'
expid <- 'a3m9'
lat_min <- -90
lat_max <- 90
lon_min_exp <- 0
lon_max_exp <- 359.99
grid_mod <- 'gr'
startdates <- c('1993','1995','1998','2000','2003','2005','2008','2010','2013')
forecast_month <- c(11,12,1,2,3,4,5) 
nforecast_month <- length(forecast_month)

path <- paste0('/esarchive/exp/ecearth/',expid,'/', folder, '/DCPP/EC-Earth-Consortium/', model, 
               '/dcppA-hindcast/', memb, '/', compo,'/$var$/',grid_mod,'/v*/$var$_',compo,'_',model,
               '_dcppA-hindcast_s$sdate$-', memb, '_', grid_mod,'_$chunk$.nc')


path <- paste0('/esarchive/exp/ecearth/a3m9/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3-HR/',
               'dcppA-hindcast/r1i1p1f1/Amon/$var$/gr/v20210324/',
               '$var$_Amon_EC-Earth3-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gr_$chunk$.nc')

data_exp_retrieve <- startR::Start(dat = path,
                                   var = vari,
                                   sdate = startdates, #paste(seq(yr1,yr2)),
                                   chunk = 'all',
                                   time = c(1:length(forecast_month)),  
                                   chunk_depends = 'sdate',
                                   time_across = 'chunk', 
                                   merge_across_dims = TRUE,
                                   lat = values(list(lat_min, lat_max)),
                                   lat_reorder = Sort(),
                                   lon = values(list(lon_min_exp, lon_max_exp)),
#                                   lon_reorder = CircularSort(-180,180),
                                   lon_reorder = CircularSort(0, 360),
                                   synonims = list(lon = c('lon', 'longitude'),
                                                   lat = c('lat', 'latitude')),
                                   return_vars = list(time= c('sdate','chunk'), 
                                                      lat='dat', 
                                                      lon='dat'),
                                   retrieve = T)

