library(startR)

  repos <- "/esarchive/exp/ecmwf/system5_m1/monthly_mean/tas_f6h/$var$_$sdate$.nc"
  var <- 'tas'
  lon.min <- 170
  lon.max <- 185  #359.723 #360
  lat.min <- -10  #-90
  lat.max <- 20  #90
  qwe <- Start(dat = repos,
                var = var,
                sdate = c('20170101'),
                ensemble = indices(1),
                time = indices(1),
                latitude = values(list(lat.min, lat.max)),
                latitude_reorder = Sort(decreasing = T),
                longitude = values(list(lon.min, lon.max)),
               # longitude_reorder = CircularSort(0, 360),
               longitude_reorder = CircularSort(-180, 180),

               transform = CDORemapper,
               transform_extra_cells = 0,
               transform_params = list(
                 grid = 'r360x181',
                 method = 'con',
                 crop = c(lon.min,lon.max,lat.min,lat.max)
               ), 
               transform_vars = c('latitude', 'longitude'), 

                return_vars = list(time = 'sdate',
                                   longitude = 'dat',
                                   latitude = 'dat'),
                retrieve = T
               )

