library(startR)

  repos <- "/esarchive/exp/ecmwf/system5_m1/monthly_mean/tas_f6h/$var$_$sdate$.nc"
  var <- 'tas'
  sdate <- c('20170101', '20170201')
  data <- Start(dat = repos,
                var = var, #c('tas', 'latitude', 'longitude'), #lat and lon are NANs
                sdate = values(c('20170101', '20170401')), #indices(1),
                ensemble = 'all', #indices(1),
                time = 'all', #indices(1), 
                latitude = indices(1:300), #'all',
                longitude = indices(1:320),  #'all',
                return_vars = list(time = c('sdate'), longitude = NULL, latitude = NULL),
                retrieve = FALSE
               )
  func <- function(x) {
#     apply(x + 1, 2, mean)
    a <- apply(x + 1, 2, mean)
    dim(a) <- c(time = length(a))   #give it a name!!!!
    return(a)
  }
  step <- Step(func, target_dims = c('ensemble', 'time'),
                    output_dims = c('time'))
  wf <- AddStep(data, step)

#-------------------user-defined---------------------
  queue_host <- 'nord1'
  temp_dir <- '/gpfs/scratch/bsc32/bsc32734/startR_hpc/'
  ecflow_suite_dir <- '/home/Earth/aho/startR_local/'
#----------------------------------------------------

  res <- Compute(wf,
                 chunks = list(latitude = 2,
                               longitude = 2),#$output1
                 threads_load = 2,
                 threads_compute = 4,
                 cluster = list(queue_host = queue_host,
                   queue_type = 'lsf',
                   temp_dir = temp_dir,
                   cores_per_job = 2,
                   job_wallclock = '05:00',
                   max_jobs = 4,
                   extra_queue_params = list('#BSUB -q bsc_es'),
                   bidirectional = FALSE,
                   polling_period = 10
                 ),
                 ecflow_suite_dir = ecflow_suite_dir,
                 wait = TRUE
                 )  #$output1

#  saveRDS(res, file = 'test_data_p9.Rds')

