library(startR)

repos <- paste0('/esarchive/exp/ecearth/a1tr/diags/CMIP/EC-Earth-Consortium/',
                'EC-Earth3/historical/r24i1p1f1/Omon/$var$/gn/v20190312/',
                '$var$_Omon_EC-Earth3_historical_r24i1p1f1_gn_$period$.nc')
var <- 'heatc0-300m'

#dimensions:
#        time = 12 ;
#        i = 362 ;
#        j = 292 ;

#heatc0-300m(time, j, i)

      data <- Start(dat = repos,
                    var = var,
                    period = 'first', #indices(1:5),
                    time = 'first',
                    j = 'all', #indices(1 : 100),
                    i = 'all', #indices(1 : 100),
                    #j_var = 'latitude',
                    #i_var = 'longitude',
                    #return_vars = list(latitude = NULL, longitude = NULL),
                    retrieve = TRUE)

  str(attr(data, 'Variables')$common)
ii <- as.vector(attr(data, 'Variables')$common$i)
jj <- as.vector(attr(data, 'Variables')$common$j)
dat <- Subset(data, c(1,2,3,4), list(1,1,1,1), drop = 'selected')

reposs <- paste0('/esarchive/exp/ecearth/a1tr/diags/CMIP/EC-Earth-Consortium/',
                'EC-Earth3/historical/r24i1p1f1/Omon/heatc0-300m/gn/v20190312/',
                'heatc0-300m_Omon_EC-Earth3_historical_r24i1p1f1_gn_$period$.nc')

      lats <- Start(dat = reposs,
                    var = 'latitude',
                    period = 'first', #indices(1:5),
                    #time = 'first',
                    j = 'all', #indices(1 : 100),
                    i = 'all', #indices(1 : 100),
                    #j_var = 'latitude',
                    #i_var = 'longitude',
                    #return_vars = list(latitude = NULL, longitude = NULL),
                    retrieve = TRUE)
  lats <- Subset(lats, c(1,2,3), list(1,1,1), drop = 'selected')



      lons <- Start(dat = reposs,
                    var = 'longitude',
                    period = 'first', #indices(1:5),
                    #time = 'first',
                    j = 'all', #indices(1 : 100),
                    i = 'all', #indices(1 : 100),
                    #j_var = 'latitude',
                    #i_var = 'longitude',
                    #return_vars = list(latitude = NULL, longitude = NULL),
                    retrieve = TRUE)
  lons <- Subset(lons, c(1,2,3), list(1,1,1), drop = 'selected')



library(s2dverification)
  asd <- CDORemap(data_array = dat, lons = lons, lats = lats, grid = 'r360x180', method = 'bil')
  latt <- as.vector(asd$lats)
  lonn <- as.vector(asd$lons)
  
PlotEquiMap(asd$data_array,lonn,latt)
