**transfer remote data to local**   
(on local)  
scp aho@bscearthxxx.int.bsc.es:/folder/optionalfile.X /yourlocalpath/optionalfile.X  
scp aho@bscearth323.int.bsc.es:/home/Earth/aho/startR_v2.1.1.tar.gz .  
scp aho@bscesshiny01.bsc.es:/srv/shiny-server/es/cp_shiny-figure-dev/ui.R .  
scp bsc32734@nord1.bsc.es:/home/bsc32/bsc32734/observed_regimes.png .  
(on local also. tranfer local file to remote)  
scp startR_tutorial_20200902.pdf aho@bscearth323.int.bsc.es:/home/Earth/aho/  

webmail.bsc.es  
intranet.bsc.es  

coarse res: /esarchive/exp/ncar/cesm-dple/monthly_mean/psl  
Dataset with 1 degree resolution is for instance system5_c3s  

**Install certain version/branch from GitLab**  
```r
devtools::install_git('https://earth.bsc.es/gitlab/es/s2dv', ref = 'master')  
devtools::install_git('https://earth.bsc.es/gitlab/es/s2dv', branch = 'develop-Season_compiled')  
```

**Install stable version**   
```r
install.packages("/esarchive/scratch/nperez/sourceR/startR_0.1.3.tar.gz", source = TRUE, repos = NULL)  
```

**Install local package**  
install.packages(path_to_file, repos = NULL, type="source")  

**Change the local startR to shared lib**  
```r
.libPaths()  # look at the library path  
require(startR, lib.loc = "/shared/earth/software/R/3.2.0-foss-2015a-bare/lib64/R/library") #change the loaded library  
detach('package:startR', unload=TRUE) #change to another library  
```

**Develop startR**  
```r
#source all the .R files  
f <- list.files("/home/Earth/aho/startR/R")  
ff <- lapply(f, function(x) paste0("/home/Earth/aho/startR/R/", x))  
invisible(lapply(ff,source))
#load all the libraries
lib <- c('parallel', 'abind', 'bigmemory', 'future', 'multiApply')
invisible(lapply(lib, library, character.only = TRUE))
```

**shiny log for debugging**  
```
cd /var/log/shiny-server/
tail -f 
less
sudo su
```

**Packages in shiny VM**  
/usr/lib64/R/library  

**Power9 interactive session**  
salloc -t 2-00:00:00 -n 1 -c 1 --mem 10000 -J PostProc --x11

**Mount on my laptop**  
\\sshfs\aho@bscearth000.int.bsc.es\..\..\..

**open browser locally through ssh to remote machine**  
in my local env (cmd or powershell),  
ssh -N -f -L localhost:9999:localhost:9999 aho@bscearth323.int.bsc.es  
open in my browser, type localhost:9999 in laptop browser  

ssh -N -f -L localhost:9999:127.0.0.1:5696 aho@bscesshiny.bsc.es  

ssh -N -f -L 9999:localhost:3434 aho@bscearth323.int.bsc.es  

**Replace a string in several files under one folder**  
sed -i 's/foo/bar/g' *  
(foo will be replaced by bar)  

**Check R package in CRAN enviroment**  
```r
devtools::check(env_vars = c(NOT_CRAN = 'false'))
```

**Nord3 interactive**  
bsub -q interactive -W 12:00 -n 1 -M 16000 -Is /bin/bash  

**Mount esarchive on shiny VM**  
kserrade@bscesshiny01:~> sudo su  
bscesshiny01:/home/kserrade # mount -a  

**Restart shiny server**  
sudo su  
systemctl restart shiny-server  

**Search a string in files in linux**  
grep -r "string"  

**Keep failing login (ssh remote)**  
lsof +D .vscode-server/  
kill <PID>  
rm -rf .vscode-server/  

**Forgot to do the development in new branch**  
If already did the commit in master but not git push yet ->  
1. git checkout -b develop-<new_branch> (so the commit is in the new branch)  
2. git checkout master  
3. git reset --hard origin/master (so the commit is gone. master is back to the original status)  
4. git checkout deveop-<new_branch>, then git push it  

